Module rubux.phisics

ModuleInfo "Version: 1.01"
ModuleInfo "Module Author: Andry Gutyria, RubuX Software"
ModuleInfo "Authors: RubuX Sowftware"
ModuleInfo "Copyright: LGPL"

'Changes Log:
Rem
	=======================================
		08.07.08 - Version 1.1 
	Added Functions:
		pxDriverSetMode(mode%)
		
		pxShapesGetNumber%(body%)
		pxShapesGetShape%(body%, num%)
		pxShapesGetPositionX#(shape%)
		pxShapesGetPositionY#(shape%)
		pxShapesGetPositionZ#(shape%)
		pxShapesGetRotationPitch#(shape%)
		pxShapesGetRotationYaw#(shape%)
		pxShapesGetRotationRoll#(shape%)
		pxShapesSetPosition(num%, pos_x#, pos_y#, pos_z#)
		pxShapesSetRotation(num%, pitch#, yaw#, roll#)
		pxContactGetShape%(body%, coll%)
		
		pxClothGetTearVertex(Cloth%, vbank:Byte Ptr)
		pxClothGetTearIndices(Cloth%, ibank:Byte Ptr)
		pxClothGetTearPIndices(Cloth%, ibank:Byte Ptr)
		pxClothGetNumTearVertex%(Cloth%)
		pxClothGetNumTearTris%(Cloth%)
		
	Changed Function Names:
		pxBodySetBodyName - pxBodySetName
		pxGetbodyName - pxBodyGetName
		pxGetbodyEntity - pxBodyGetEntity
		pxBodySetBodyUserData - pxBodySetUserData
		pxGetBodyUserData - pxBodyGetUserData
End Rem


Extern "win32"
	Function FindWindowA:Int(class:Int, title$Z) 
	Function LoadLibraryA(lib$Z) 
	Function GetProcAddress:Byte Ptr(lib:Int, fname$Z) 
End Extern

Global lib:Int = LoadLibraryA("Blitzpx.dll") 

' Main
Global pxGetNumberAllBody:Int() "win32"
Global pxCreateWorld:Int(PLANE:Int, password:Byte Ptr) "win32"
Global PxCreateWorldWithoutDrivers:Int(PLANE:Int, password:Byte Ptr) "win32"
Global pxDestroyWorld() "win32"
Global pxRenderPhysic(Time:Float, sinc:Int) "win32"
Global pxSetTiming(maxTimeStep:Float, maxvIter:Int, StepMethod:Int) "win32"
Global pxSDKSetParameter(param:Float) "win32"
Global pxSetPause(pause:Int) "win32"
Global pxChekPPU:Int() "win32"
Global pxChekPPUMode:Int() "win32"
Global pxSetHardwareSimulation(mode:Int) "win32"
Global pxDriverSetMode(mode:Int) "win32"
' Scene
Global pxCreateScene:Int() "win32"
Global pxSceneChange(scene:Int) "win32"

' Buffer
Global pxBufferCreate:Int(Size:Int) "win32"
Global pxBufferSetElement(buff:Int, nelem:Int, elem:Float) "win32"
Global pxBufferGetElement:Float(buff:Int, elem:Int) "win32"
Global pxBufferDelete(buff:Int) "win32"

' Register
Global pxRegWriteDriverPath:Int(str:Byte Ptr) "win32"
Global pxRegWriteString:Int(RootKey:Int, Path:Byte Ptr, name:Byte Ptr, Data:Byte Ptr) "win32"
Global pxRegWriteInt:Int(RootKey:Int, Path:Byte Ptr, name:Byte Ptr, Data:Int) "win32"
Global pxRegReadInt:Int(RootKey:Int, Path:Byte Ptr, Name:Byte Ptr) "win32"
Global pxRegReadString:Byte Ptr(RootKey:Int, Path:Byte Ptr, name:Byte Ptr) "win32"
Global pxRegDeleteValue:Int(RootKey:Int, Path:Byte Ptr, name:Byte Ptr) "win32"
Global pxRegDeleteKey:Int(RootKey:Int, Path:Byte Ptr, Name:Byte Ptr) "win32"

' CCD Skeleton
Global pxCCDSkeletonEnable(mode:Int) "win32"
Global pxCCDSkeletonSetEpsilon(eps:Float) "win32"
Global pxBodySetCCDSkeleton(body:Int, X:Float, Y:Float, Z:Float) "win32"
Global pxBodySetCCDSkeletonThreshold(body:Int, thres:Float) "win32"
Global pxBodySetFlagCCDSkeletonDynamic(body:Int) "win32"
Global pxBodyGetCCDSkeleton:Int(body:Int) "win32"
Global pxBodyDeleteCCDSkeleton(ccd:Int) "win32"

' Irr
Global pxIrrGetPosMat(BODY:Int, irrMat:Byte Ptr) "win32"
Global pxIrrGetPosElem:Float(body:Int) "win32"
Global pxIrrGetRotElem:Float(body:Int) "win32"


' Force Field
Global pxCreateForceField:Int() "win32"
Global pxForceFieldUpdate(FField:Int) "win32"
Global pxForceFieldGetConstant:Float(FField:Int) "win32"


' Magnet
Global pxCreateMagnet:Int(minforce:Float, middleforce:Float, maxvforce:Float) "win32"
Global pxMagnetActivate(mdata:Int, mmode:Int, fmode:Int) "win32"
Global pxMagnetSetPosition(mdata:Int, pos_x:Float, pos_y:Float, pos_z:Float) "win32"
Global pxMagnetSetMaxRadius(mdata:Int, radius:Float) "win32"
Global pxMagnetSetMinRadius(mdata:Int, radius:Float) "win32"
Global pxMagnetSetMaxForce(mdata:Int, force:Float) "win32"
Global pxMagnetSetMidForce(mdata:Int, force:Float) "win32"
Global pxMagnetSetMinForce(mdata:Int, force:Float) "win32"
Global pxMagnetSetMask(mdata:Int, mask:Int) "win32"
Global pxMagnetGetPositionX:Float(mdata:Int) "win32"
Global pxMagnetGetPositionY:Float(mdata:Int) "win32"
Global pxMagnetGetPositionZ:Float(mdata:Int) "win32"
Global pxMagnetGetMaxRadius:Float(mdata:Int) "win32"
Global pxMagnetGetMinRadius:Float(mdata:Int) "win32"
Global pxMagnetGetMaxForce:Float(mdata:Int) "win32"
Global pxMagnetGetMidForce:Float(mdata:Int) "win32"
Global pxMagnetGetMinForce:Float(mdata:Int) "win32"
Global pxMagnetGetMask:Int(mdata:Int) "win32"
Global pxMagnetDelete(mdata:Int) "win32"


' Ray
Global pxCreateRay:Int() "win32"
Global pxRaySetDir(ray:Int, nx:Float, ny:Float, nz:Float) "win32"
Global pxRaySetPosition(ray:Int, X:Float, Y:Float, Z:Float) "win32"
Global pxRayGetDistance:Float(ray:Int, mode:Int) "win32"
Global pxRayGetBody:Int(ray:Int, mode:Int) "win32"
Global pxRayGetMaterial:Int(ray:Int, mode:Int) "win32"
Global pxRayGetPickX:Float(ray:Int, mode:Int) "win32"
Global pxRayGetPickY:Float(ray:Int, mode:Int) "win32"
Global pxRayGetPickZ:Float(ray:Int, mode:Int) "win32"
Global pxRayGetPickNX:Float(ray:Int, mode:Int) "win32"
Global pxRayGetPickNY:Float(ray:Int, mode:Int) "win32"
Global pxRayGetPickNZ:Float(ray:Int, mode:Int) "win32"


' Trigger
Global pxTriggerCreateCube:Int(dx:Float, dy:Float, dz:Float) "win32"
Global pxTriggerCreateSphere:Int(radius:Float) "win32"
Global pxTriggerCreateCapsule:Int(Height:Float, radius:Float) "win32"
Global pxTriggerCreateCylinder:Int(radius:Float, Height:Float, nbEdge:Int) "win32"
Global pxTriggerCreateHull:Int(vbank:Byte Ptr, nvert:Int) "win32"
Global pxTriggerSetPosition(body:Int, X:Float, Y:Float, Z:Float) "win32"
Global pxTriggerSetRotation(body:Int, Pitch:Float, Yaw:Float, Roll:Float) "win32"
Global pxTriggerGetNumBody:Int(trigger:Int) "win32"
Global pxTriggerGetBody:Int(trigger:Int, num:Int) "win32"
Global pxTriggerGetBodyTrigger:Int(body:Int) "win32"
Global pxUpdateTriggers() "win32"


' TriMesh
Global pxCreateTriMeshPmap:Int(vbank:Byte Ptr, fbank:Byte Ptr, MESH_NBVERTICES:Int, MESH_NBFACES:Int, file_name:Byte Ptr, pMap:Int) "win32"
Global pxCreateTriMeshFromPmap:Int(triangleMesh:Int, mass:Float) "win32"
Global pxCreateTriMesh:Int(vbank:Byte Ptr, fbank:Byte Ptr, MESH_NBVERTICES:Int, MESH_NBFACES:Int, mass:Float) "win32"
Global pxCreateTerrain:Int(nSize:Int, bank:Byte Ptr, scale_x:Float, scale_y:Float, scale_z:Float) "win32"
Global pxCreateTerrainFromMesh:Int(vbank:Byte Ptr, fbank:Byte Ptr, MESH_NBVERTICES:Int, MESH_NBFACES:Int, axis:Float) "win32"
Global pxCreateTerrainPmap(vbank:Byte Ptr, fbank:Byte Ptr, MESH_NBVERTICES:Int, MESH_NBFACES:Int, axis:Float, file_name:Byte Ptr, pMap:Int) "win32"
Global pxTestTriMesh:Int(entity:Int, mass:Float) "win32"
Global pxCreateTriMeshToFile:Int(vbank:Byte Ptr, fbank:Byte Ptr, MESH_NBVERTICES:Int, MESH_NBFACES:Int, fname:Byte Ptr) "win32"
Global pxCreateTriMeshFromFile:Int(fname:Byte Ptr, mass:Float) "win32"
' Body
Global pxBodyCreatePlane:Int(X:Float, Y:Float, Z:Float) "win32"
Global pxBodyCreateCube:Int(dx:Float, dy:Float, dz:Float, mass:Float) "win32"
Global pxBodyCreateSphere:Int(radius:Float, mass:Float) "win32"
Global pxBodyCreateCapsule:Int(Height:Float, radius:Float, mass:Float) "win32"
Global pxBodyCreateCylinder:Int(radius:Float, Height:Float, nbEdge:Int, mass:Float) "win32"
Global pxBodyCreateHull:Int(vbank:Byte Ptr, nvert:Int, mass:Float) "win32"
Global pxBodyCreateHullFromSSM:Int(surf:Int, mass:Float) "win32"
Global pxAddBodytoBody(body1:Int, body2:Int) "win32"
Global pxCopyBody:Int(body:Int) "win32"
Global pxDeleteBody(num:Int) "win32"
' Body Options
Global pxBodySetName(body:Int, Name:Byte Ptr) "win32"
Global pxBodyGetName:Byte Ptr(body:Int) "win32"
Global pxBodySetEntity:Int(entity:Int, body:Int) "win32"
Global pxDX9BodySetEntity:Int(entity:Int, body:Int) "win32"
Global pxBodyAddEntity(entity:Int, body:Int) "win32"
Global pxBodyGetEntity:Int(body:Int) "win32"
Global pxBodySetUserData(body:Int, userdata:Int) "win32"
Global pxBodyGetUserData:Int(body:Int) "win32"
Global pxBodySetSolverIterationCount(body:Int, itercount:Int) "win32"

' Body Froze
Global pxBodySetFrozen(body:Int, stat:Int) "win32"
Global pxBodySetFrozenRotX(body:Int, stat:Int) "win32"
Global pxBodySetFrozenRotY(body:Int, stat:Int) "win32"
Global pxBodySetFrozenRotZ(body:Int, stat:Int) "win32"
Global pxBodySetFrozenRot(body:Int, stat:Int) "win32"
Global pxBodySetFrozenPosX(body:Int, stat:Int) "win32"
Global pxBodySetFrozenPosY(body:Int, stat:Int) "win32"
Global pxBodySetFrozenPosZ(body:Int, stat:Int) "win32"
Global pxBodySetFrozenPos(body:Int, stat:Int) "win32"
' Body Sleep
Global pxBodySetSleepEnergyThreshold(body:Int, tres:Float) "win32"
Global pxBodySetSleepAngularVelocity(body:Int, tres:Float) "win32"
Global pxBodyGetSleepAngularVelocity:Float(body:Int) "win32"
Global pxBodySetSleepLinearVelocity(body:Int, tres:Float) "win32"
Global pxBodyGetSleepLinearVelocity:Float(body:Int) "win32"
Global pxBodySetSleepWakeUp(body:Int, wakeCounterValue:Float) "win32"
Global pxBodySetSleepPut(body:Int) "win32"
Global pxBodyIsDynamic:Int(body:Int) "win32"
Global pxBodyIsSleeping:Int(body:Int) "win32"
' Body Flag
Global pxBodySetFlagGravity(body:Int, stat:Int) "win32"
Global pxBodySetFlagCollision(body:Int, stat:Int) "win32"
Global pxBodySetFlagResponse(body:Int, stat:Int) "win32"
Global pxBodySetFlagContacttable(body:Int, stat:Int) "win32"
Global pxBodySetFlagMagniteble(body:Int, stat:Int) "win32"
Global pxBodySetFlagTriggertable(body:Int, stat:Int) "win32"
Global pxBodySetFlagRayCast(body:Int, stat:Int) "win32"
' Body Mass
Global pxSetGravity(gx:Float, gy:Float, gz:Float) "win32"
Global pxBodySetMass(num:Int, mass:Float) "win32"
Global pxBodySetCMassLocalPosition(num:Int, X:Float, Y:Float, Z:Float) "win32"
Global pxBodySetCMassGlobalPosition(num:Int, X:Float, Y:Float, Z:Float) "win32"
Global pxBodySetMassSpaceInertiaTensor(num:Int, X:Float, Y:Float, Z:Float) "win32"
Global pxBodyGetCMassGlobalPositionX:Float(body:Int) "win32"
Global pxBodyGetCMassGlobalPositionY:Float(body:Int) "win32"
Global pxBodyGetCMassGlobalPositionZ:Float(body:Int) "win32"
Global pxBodyGetCMassLocalPositionX:Float(body:Int) "win32"
Global pxBodyGetCMassLocalPositionY:Float(body:Int) "win32"
Global pxBodyGetCMassLocalPositionZ:Float(body:Int) "win32"
Global pxBodyGetMass:Float(body:Int) "win32"
' Body Position
Global pxBodySetPosition(num:Int, pos_x:Float, pos_y:Float, pos_z:Float) "win32"
Global pxBodyGetPositionX:Float(num:Int) "win32"
Global pxBodyGetPositionY:Float(num:Int) "win32"
Global pxBodyGetPositionZ:Float(num:Int) "win32"
Global pxBodyGetLinearDamping:Float(body:Int) "win32"
Global pxBodyGetLinearMomentum:Float(body:Int) "win32"
Global pxBodyGetLinearSpeed:Float(num:Int) "win32"
Global pxBodyGetLinearSpeedX:Float(num:Int) "win32"
Global pxBodyGetLinearSpeedY:Float(num:Int) "win32"
Global pxBodyGetLinearSpeedZ:Float(num:Int) "win32"
Global pxBodyGetLocalLinearSpeedX:Float(body:Int) "win32"
Global pxBodyGetLocalLinearSpeedY:Float(body:Int) "win32"
Global pxBodyGetLocalLinearSpeedZ:Float(body:Int) "win32"
Global pxBodyGetLinearVecSpeedX:Float(num:Int) "win32"
Global pxBodyGetLinearVecSpeedY:Float(num:Int) "win32"
Global pxBodyGetLinearVecSpeedZ:Float(num:Int) "win32"
Global pxBodyGetLocalPointSpeed(body:Int, X:Float, Y:Float, Z:Float) "win32"
Global pxBodyGetLocalPointSpeedX(body:Int, X:Float, Y:Float, Z:Float) "win32"
Global pxBodyGetLocalPointSpeedY(body:Int, X:Float, Y:Float, Z:Float) "win32"
Global pxBodyGetLocalPointSpeedZ(body:Int, X:Float, Y:Float, Z:Float) "win32"
' Body Get Angular
Global pxBodySetRotation(num:Int, Pitch:Float, Yaw:Float, Roll:Float) "win32"
Global pxBodyGetRotationPitch:Float(num:Int) "win32"
Global pxBodyGetRotationYaw:Float(num:Int) "win32"
Global pxBodyGetRotationRoll:Float(num:Int) "win32"
Global pxBodyGetAngularDamping:Float(body:Int) "win32"
Global pxBodyGetAngularMomentum:Float(body:Int) "win32"
Global pxBodyGetMaxAngularVelocity:Float(body:Int) "win32"
Global pxBodyGetAngularSpeed:Float(num:Int) "win32"
Global pxBodyGetAngularSpeedX:Float(num:Int) "win32"
Global pxBodyGetAngularSpeedY:Float(num:Int) "win32"
Global pxBodyGetAngularSpeedZ:Float(num:Int) "win32"
Global pxBodyGetLocalAngularSpeedX:Float(body:Int) "win32"
Global pxBodyGetLocalAngularSpeedY:Float(body:Int) "win32"
Global pxBodyGetLocalAngularSpeedZ:Float(body:Int) "win32"
' Body Force
Global pxBodySetMyForce(body:Int, lx:Float, ly:Float, lz:Float) "win32"
Global pxBodyAddForce(num:Int, vx:Float, vy:Float, vz:Float, mode:Int) "win32"
Global pxBodyAddForceAtPos(num:Int, vx:Float, vy:Float, vz:Float, px:Float, py:Float, pz:Float, mode:Int) "win32"
Global pxBodyAddForceAtLocalPos(body:Int, vx:Float, vy:Float, vz:Float, px:Float, py:Float, pz:Float, mode:Int) "win32"
Global pxBodyAddLocalForce(num:Int, vx:Float, vy:Float, vz:Float, mode:Int) "win32"
Global pxBodyAddLocalForceAtPos(num:Int, vx:Float, vy:Float, vz:Float, px:Float, py:Float, pz:Float, mode:Int) "win32"
Global pxBodyAddLocalForceAtLocalPos(body:Int, vx:Float, vy:Float, vz:Float, px:Float, py:Float, pz:Float, mode:Int) "win32"
Global pxMoveBodyToPoint(body:Int, maxvspeed:Float, X:Float, Y:Float, Z:Float) "win32"
' Body Set Angular
Global pxBodyAddTorque(body:Int, vx:Float, vy:Float, vz:Float, mode:Int) "win32"
Global pxBodyAddLocalTorque(body:Int, vx:Float, vy:Float, vz:Float, mode:Int) "win32"
Global pxBodySetAngularSpeed(body:Int, ax:Float, ay:Float, az:Float) "win32"
Global pxBodySetLinearSpeed(body:Int, lx:Float, ly:Float, lz:Float) "win32"
Global pxBodySetLocalLinearSpeed(body:Int, lx:Float, ly:Float, lz:Float) "win32"
Global pxBodySetLocalAngularSpeed(body:Int, lx:Float, ly:Float, lz:Float) "win32"
Global pxBodySetAngularDamping(body:Int, angDamp:Float) "win32"
Global pxBodySetLinearDamping(body:Int, linDamp:Float) "win32"
Global pxBodySetAngularMomentum(body:Int, ax:Float, ay:Float, az:Float) "win32"
Global pxBodySetLinearMomentum(body:Int, lx:Float, ly:Float, lz:Float) "win32"
Global pxBodySetMaxAngularSpeed(body:Int, speed:Float) "win32"


' Compound
Global pxCreateCompoundDesc:Int() "win32"
Global pxCompoundAddCubeShape:Int(compoundDesc:Int, dx:Float, dy:Float, dz:Float) "win32"
Global pxCompoundAddSphereShape:Int(compoundDesc:Int, radius:Float) "win32"
Global pxCompoundAddCapsuleShape:Int(compoundDesc:Int, radius:Float, Height:Float) "win32"
Global pxCompoundAddCylinderShape:Int(compoundDesc:Int, radius:Float, Height:Float, nbEdge:Int) "win32"
Global pxCompoundAddHullShape:Int(compoundDesc:Int, vbank:Byte Ptr, nvert:Int) "win32"
Global pxCompoundSetShapePos(shape:Int, X:Float, Y:Float, Z:Float) "win32"
Global pxCompoundSetShapeRot(shape:Int, Pitch:Float, Yaw:Float, Roll:Float) "win32"
Global pxCreateCompound:Int(compoundDesc:Int, mass:Float) "win32"
Global pxCreateStaticCompound:Int(compoundDesc:Int, mass:Float) "win32"
' Shape
Global pxShapesGetNumber:Int(body:Int) "win32"
Global pxShapesGetShape:Int(body:Int, num:Int) "win32"
Global pxShapesGetPositionX:Float(shape:Int) "win32"
Global pxShapesGetPositionY:Float(shape:Int) "win32"
Global pxShapesGetPositionZ:Float(shape:Int) "win32"
Global pxShapesGetRotationPitch:Float(shape:Int) "win32"
Global pxShapesGetRotationYaw:Float(shape:Int) "win32"
Global pxShapesGetRotationRoll:Float(shape:Int) "win32"
Global pxShapesSetPosition(num:Int, pos_x:Float, pos_y:Float, pos_z:Float) "win32"
Global pxShapesSetRotation(num:Int, pitch:Float, yaw:Float, roll:Float) "win32"
Global pxContactGetShape:Int(body:Int, coll:Int) "win32"


' Kinematic
Global pxKinematicSet(body:Int) "win32"
Global pxKinematicClear(body:Int) "win32"
Global pxKinematicMove(body:Int, X:Float, Y:Float, Z:Float) "win32"
Global pxKinematicSetPosition(body:Int, X:Float, Y:Float, Z:Float) "win32"
Global pxKinematicSetRotation(body:Int, Pitch:Float, Yaw:Float, Roll:Float) "win32"


' Material
Global pxCreateMaterial:Int() "win32"
Global pxMaterialSetToBody(body:Int, mat:Int) "win32"
Global pxMaterialSetRestitution(mat:Int, rest:Float) "win32"
Global pxMaterialSetRestitutionCombineMode(mat:Int, mode:Int) "win32"
Global pxMaterialSetStFriction(mat:Int, fric:Float) "win32"
Global pxMaterialSetDyFriction(mat:Int, fric:Float) "win32"
Global pxMaterialSetFrictionV(mat:Int, sfric:Float, dfric:Float) "win32"
Global pxMaterialSetFrictionCombineMode(mat:Int, mode:Int) "win32"
Global pxCreateAnisotripicMaterial:Int(nx:Float, ny:Float, nz:Float) "win32"
Global pxMaterialSetFlagStrongFriction(mat:Int) "win32"
Global pxGetMaterial:Int(body:Int) "win32"


' Mask
Global pxMaskSet(body:Int, mask:Int) "win32"
Global pxMaskCombineSet(body:Int, mask:Int) "win32"
Global pxMaskClear(body:Int) "win32"
Global pxBodySetCollisionGroup(body:Int, group:Int) "win32"
Global pxBodySetCollisionGroupPair(group1:Int, group2:Int) "win32"
Global pxBodySetCollisionGroupFlag(group1:Int, group2:Int, flag:Int) "win32"
Global pxBodySetMagnetMask(body:Int, mask:Int) "win32"
Global pxBodyGetMagnetMask:Int(body:Int) "win32"


' Contacts
Global pxGetContacts:Int(body:Int) "win32"
Global pxContactGetBody:Int(body:Int, coll:Int) "win32"
Global pxContactGetPointX:Float(body:Int, coll:Int) "win32"
Global pxContactGetPointY:Float(body:Int, coll:Int) "win32"
Global pxContactGetPointZ:Float(body:Int, coll:Int) "win32"
Global pxContactGetPointNX:Float(body:Int, coll:Int) "win32"
Global pxContactGetPointNY:Float(body:Int, coll:Int) "win32"
Global pxContactGetPointNZ:Float(body:Int, coll:Int) "win32"
Global pxContactGetForceN:Float(body:Int, coll:Int) "win32"
Global pxContactGetForceNX:Float(body:Int, coll:Int) "win32"
Global pxContactGetForceNY:Float(body:Int, coll:Int) "win32"
Global pxContactGetForceNZ:Float(body:Int, coll:Int) "win32"
Global pxContactGetForceT:Float(body:Int, coll:Int) "win32"
Global pxContactGetForceTX:Float(body:Int, coll:Int) "win32"
Global pxContactGetForceTY:Float(body:Int, coll:Int) "win32"
Global pxContactGetForceTZ:Float(body:Int, coll:Int) "win32"
Global pxContactEventsOnStartTouch:Int(body:Int) "win32"
Global pxContactEventsOnEndTouch:Int(body:Int) "win32"


' Water
Global pxCreateWaterCirPlane:Int(radius:Float, depth:Float) "win32"
Global pxCreateWaterRectPlane:Int(width:Float, Height:Float, depth:Float) "win32"
Global pxCreateWaterInfinPlane:Int(depth:Float) "win32"
Global pxWaterSetDimension(water:Int, width:Float, Height:Float) "win32"
Global pxWaterSetRadius(water:Int, radius:Float) "win32"
Global pxWaterSetPosition(water:Int, pos_x:Float, pos_y:Float, pos_z:Float) "win32"
Global pxWaterSetRotation(water:Int, angle:Float) "win32"
Global pxWaterSetFluxion(water:Int, fl_x:Float, fl_y:Float, fl_z:Float) "win32"
Global pxWaterGetWidth:Float(water:Int) "win32"
Global pxWaterGetHeight:Float(water:Int) "win32"
Global pxWaterGetRadius:Float(water:Int) "win32"
Global pxWaterGetPositionX:Float(water:Int) "win32"
Global pxWaterGetPositionY:Float(water:Int) "win32"
Global pxWaterGetPositionZ:Float(water:Int) "win32"
Global pxWaterGetRotation:Float(water:Int) "win32"
Global pxWaterGetDepth:Float(water:Int) "win32"
Global pxWaterDelete(water:Int) "win32"

' Keep
Global pxCreateKep:Int(buo:Float, radius:Float, maxvdis:Float) "win32"
Global pxKepAddToBody(kdata:Int, body:Int) "win32"
Global pxKepSetLocalPosition(kdata:Int, pos_x:Float, pos_y:Float, pos_z:Float) "win32"
Global pxKepSetGlobalPosition(kdata:Int, pos_x:Float, pos_y:Float, pos_z:Float) "win32"
Global pxKepSetAngularDamping(kdata:Int, angdamp:Float) "win32"
Global pxKepSetLinearDamping(kdata:Int, lindamp:Float) "win32"
Global pxWaterUpdate(water:Int) "win32"
Global pxKepGetPosX:Float(kdata:Int) "win32"
Global pxKepGetPosY:Float(kdata:Int) "win32"
Global pxKepGetPosZ:Float(kdata:Int) "win32"
Global pxKepGetNumber:Int(body:Int) "win32"
Global pxKepGetKepFromBody:Int(body:Int, num:Int) "win32"


' Cloth
Global pxCreateCloth:Int(entity:Int, surf:Int) "win32"
Global pxCreateTearableCloth:Int(entity:Int, surf:Int) "win32"
Global pxCreateMetalCloth:Int(entity:Int, surf:Int, coreActor:Int, impThr:Float, depth:Float) "win32"
Global pxCreateClothSpec:Int(vbank:Byte Ptr, fbank:Byte Ptr, MESH_NBVERTICES:Int, MESH_NBFACES:Int) "win32"
Global pxCreateMetalClothSpec:Int(vbank:Byte Ptr, fbank:Byte Ptr, MESH_NBVERTICES:Int, MESH_NBFACES:Int, coreActor:Int, impThr:Float, depth:Float) "win32"
  
Global pxClothGetAttachmentResponseCoefficient:Float(Cloth:Int) "win32"
Global pxClothGetAttachmentTearFactor:Float(Cloth:Int) "win32"
Global pxClothGetBendingStiffness:Float(Cloth:Int) "win32"
Global pxClothGetCollisionResponseCoefficient:Float(Cloth:Int) "win32"
Global pxClothGetDampingCoefficient:Float(Cloth:Int) "win32"
Global pxClothGetDensity:Float(Cloth:Int) "win32"
Global pxClothGetFriction:Float(Cloth:Int) "win32"
Global pxClothGetPressure:Float(Cloth:Int) "win32"
Global pxClothGetSleepLinearVelocity:Float(Cloth:Int) "win32"
Global pxClothGetStretchingStiffness:Float(Cloth:Int) "win32"
Global pxClothGetTearFactor:Float(Cloth:Int) "win32"
Global pxClothGetThickness:Float(Cloth:Int) "win32"
Global pxClothGetNumVertices:Int(Cloth:Int) "win32"
Global pxClothIsSleeping:Int(Cloth:Int) "win32"
Global pxClothGetEntity:Int(Cloth:Int) "win32"
Global pxClothGetUserData:Int(Cloth:Int) "win32"
Global pxClothPutToSleep(Cloth:Int) "win32"
Global pxClothWakeUp(Cloth:Int) "win32"
Global pxClothSetGravity(Cloth:Int, stat:Int) "win32"
  
Global pxClothSetTeareble(Cloth:Int) "win32"
Global pxClothSetTearFactor(Cloth:Int, coef:Float) "win32"
  
Global pxClothSetAttachmentResponseCoefficient:Float(Cloth:Int, coef:Float) "win32"
Global pxClothSetAttachmentTearFactor:Float(Cloth:Int, coef:Float) "win32"
Global pxClothSetBending(Cloth:Int) "win32"
Global pxClothSetBendingStiffness:Float(Cloth:Int, coef:Float) "win32"
Global pxClothSetCollisionResponseCoefficient:Float(Cloth:Int, coef:Float) "win32"
Global pxClothSetDampingCoefficient:Float(Cloth:Int, coef:Float) "win32"
Global pxClothSetComDampingCoefficient:Float(Cloth:Int, coef:Float) "win32"
Global pxClothSetFriction:Float(Cloth:Int, coef:Float) "win32"
Global pxClothSetPressure:Float(Cloth:Int, coef:Float) "win32"
Global pxClothSetSleepLinearVelocity:Float(Cloth:Int, coef:Float) "win32"
Global pxClothSetStretchingStiffness:Float(Cloth:Int, coef:Float) "win32"
Global pxClothSetThickness:Float(Cloth:Int, coef:Float) "win32"
Global pxClothSetUserData(Cloth:Int, userdata:Int) "win32"
Global pxClothMaskSet(Cloth:Int, mask:Int) "win32"
Global pxClothMaskCombineSet(Cloth:Int, mask:Int) "win32"
  
Global pxClothSetVertexPos(Cloth:Int, vbank:Byte Ptr, numVert:Int) "win32"
Global pxClothGetVertexPos(Cloth:Int, vbank:Byte Ptr, numVert:Int) "win32"
Global pxClothGetNormals(Cloth:Int, nbank:Byte Ptr) "win32"
  
Global pxClothAttachVertexToPos(Cloth:Int, vID:Int, pos_x:Float, pos_y:Float, pos_z:Float) "win32"
Global pxClothAttachToCollidingShapes(Cloth:Int, flag:Int) "win32"
Global pxClothAttachToCore(Cloth:Int, body:Int, Threshold:Float, depth:Float) "win32"
Global pxClothAttachToShape(Cloth:Int, body:Int, flag:Int) "win32"
Global pxClothDetachFromShape(Cloth:Int, body:Int) "win32"
Global pxClothFreeVertex(Cloth:Int, vID:Int) "win32"
Global pxClothAddForceAtPos(Cloth:Int, pos_x:Float, pos_y:Float, pos_z:Float, magnitude:Float, radius:Float) "win32"
Global pxClothAddForceAtVertex(Cloth:Int, nx:Float, ny:Float, nz:Float, vID:Int) "win32"
Global pxUpdateCloth() "win32"
Global pxClothDelete(Cloth:Int) "win32"

Global pxClothGetTearVertex(Cloth:Int, vbank:Byte Ptr) "win32"
Global pxClothGetTearIndices(Cloth:Int, ibank:Byte Ptr) "win32"
Global pxClothGetTearPIndices(Cloth:Int, ibank:Byte Ptr) "win32"
Global pxClothGetNumTearVertex:Int(Cloth:Int) "win32"
Global pxClothGetNumTearTris:Int(Cloth:Int) "win32"


' Soft Body
Global pxCreateSoftBody:Int(OBJfile:Byte Ptr, TETfile:Byte Ptr, vbank:Byte Ptr, numVert:Int, pos_x:Float, pos_y:Float, pos_z:Float, rot_x:Float, rot_y:Float, rot_z:Float) "win32"
Global pxUpdateSoftBody(SB:Int) "win32"

Global pxSoftBodyLinkMesh(softBody:Int, vbank:Byte Ptr, numVert:Int) "win32"
Global pxSoftBodyGetNumVert:Int(SB:Int) "win32"
Global pxSoftBodyGetVertexPos(SB:Int, vbank:Byte Ptr, numVert:Int) "win32"
Global pxSoftBodyGetNormals(SB:Int, nbank:Byte Ptr, numVert:Int) "win32"
Global pxSoftBodyIsSleeping:Int(SB:Int) "win32"
Global pxSoftBodyPutToSleep(SB:Int) "win32"
Global pxSoftBodyWakeUp(SB:Int, interval:Int) "win32"
  
Global pxSoftBodySetAttachmentResponseCoefficient(softBody:Int, coef:Float) "win32"
Global pxSoftBodySetAttachmentTearFactor(softBody:Int, coef:Float) "win32"
Global pxSoftBodySetCollisionResponseCoefficient(softBody:Int, coef:Float) "win32"
Global pxSoftBodySetDampingCoefficient(softBody:Int, coef:Float) "win32"
Global pxSoftBodySetExternalAcceleration(softBody:Int, X:Float, Y:Float, Z:Float) "win32"
Global pxSoftBodySetFriction(softBody:Int, fric:Float) "win32"
Global pxSoftBodySetLinkRadius(radius:Float) "win32"
Global pxSoftBodySetMask(softBody:Int, mask:Int) "win32"
Global pxSoftBodySetMaskCombine(softBody:Int, mask:Int) "win32"
Global pxSoftBodyMaskClear(softBody:Int) "win32"
Global pxSoftBodySetName(softBody:Int, name:Byte Ptr) "win32"
Global pxSoftBodySetParticleRadius(softBody:Int, radius:Float) "win32"
Global pxSoftBodySetSleepLinearVelocity(softBody:Int, vel:Float) "win32"
Global pxSoftBodySetSolverIterations(softBody:Int, iter:Int) "win32"
Global pxSoftBodySetStretchingStiffness(softBody:Int, coef:Float) "win32"
Global pxSoftBodySetVolumeStiffness(softBody:Int, coef:Float) "win32"
Global pxSoftBodySetGravity(softBody:Int, stat:Int) "win32"
Global pxSoftBodySetStatic(softBody:Int, stat:Int) "win32"
Global pxSoftBodySetCollision(softBody:Int, stat:Int) "win32"
  
Global pxSoftBodyGetAttachmentResponseCoefficient:Float(softBody:Int) "win32"
Global pxSoftBodyGetAttachmentTearFactor:Float(softBody:Int) "win32"
Global pxSoftBodyGetCollisionResponseCoefficient:Float(softBody:Int) "win32"
Global pxSoftBodyGetDampingCoefficient:Float(softBody:Int) "win32"
Global pxSoftBodyGetFriction:Float(softBody:Int) "win32"
Global pxSoftBodyGetName:Byte Ptr(softBody:Int) "win32"
Global pxSoftBodyGetParticleRadius:Float(softBody:Int) "win32"
Global pxSoftBodyGetSleepLinearVelocity:Float(softBody:Int) "win32"
Global pxSoftBodyGetSolverIterations:Int(softBody:Int) "win32"
Global pxSoftBodyGetStretchingStiffness:Float(softBody:Int) "win32"
Global pxSoftBodyGetVolumeStiffness:Float(softBody:Int) "win32"
  
Global pxSoftBodyAttachToShape(softBody:Int, body:Int, flag:Int) "win32"
Global pxSoftBodyAttachToCollidingShapes(softBody:Int, tearable:Int) "win32"
Global pxSoftBodyDetachFromShape(softBody:Int, body:Int) "win32"
Global pxSoftBodyAttachVertexToGlobalPosition(softBody:Int, vertID:Int, X:Float, Y:Float, Z:Float) "win32"
Global pxSoftBodyFreeVertex(softBody:Int, vertID:Int) "win32"
Global pxSoftBodyAddForceAtPos(softBody:Int, pos_x:Float, pos_y:Float, pos_z:Float, magnitude:Float, radius:Float, mode:Int) "win32"
Global pxSoftBodyAddForceAtVertex(softBody:Int, X:Float, Y:Float, Z:Float, vertID:Int, mode:Int) "win32"


' Particle
Global pxParticleCreateEmitter:Int() "win32"
Global pxParticleEmitSetAngDamping(pEmitter:Int, damp:Float) "win32"
Global pxParticleEmitSetLinDamping(pEmitter:Int, damp:Float) "win32"
Global pxParticleEmitSetMass(pEmitter:Int, mass:Float) "win32"
Global pxParticleEmitSetRadius(pEmitter:Int, radius:Float) "win32"
Global pxParticleEmitSetPosition(pEmitter:Int, X:Float, Y:Float, Z:Float) "win32"
Global pxParticleEmitSetRotation(pEmitter:Int, Pitch:Float, Yaw:Float, Roll:Float) "win32"
Global pxParticleEmitSetRandRadius(pEmitter:Int, radius:Float) "win32"
Global pxParticleEmitSetStartSpeed(pEmitter:Int, minv:Float, maxv:Float) "win32"
Global pxParticleEmitSetTDAcceleration(pEmitter:Int, X:Float, Y:Float, Z:Float) "win32"
Global pxParticleEmitSetScaleFactor(pEmitter:Int, radius:Float, rate:Float) "win32"
Global pxParticleEmitDeleteFirstParticle:Int(pEmitter:Int) "win32"
Global pxParticleEmitDeleteParticle(pEmitter:Int, particle:Int) "win32"

Global pxParticleEmitGetAngDamping:Float(pEmitter:Int) "win32"
Global pxParticleEmitGetLinDamping:Float(pEmitter:Int) "win32"
Global pxParticleEmitGetMass:Float(pEmitter:Int) "win32"
Global pxParticleEmitGetRadius:Float(pEmitter:Int) "win32"
Global pxParticleEmitGetPositionX:Float(pEmitter:Int) "win32"
Global pxParticleEmitGetPositionY:Float(pEmitter:Int) "win32"
Global pxParticleEmitGetPositionZ:Float(pEmitter:Int) "win32"
Global pxParticleEmitGetRotationPitch:Float(pEmitter:Int) "win32"
Global pxParticleEmitGetRotationYaw:Float(pEmitter:Int) "win32"
Global pxParticleEmitGetRotationRoll:Float(pEmitter:Int) "win32"
Global pxParticleEmitGetRandRadius:Float(pEmitter:Int) "win32"
Global pxParticleEmitGetStartSpeedMax:Float(pEmitter:Int) "win32"
Global pxParticleEmitGetStartSpeedMin:Float(pEmitter:Int) "win32"
Global pxParticleEmitGetTDAccelerationX:Float(pEmitter:Int) "win32"
Global pxParticleEmitGetTDAccelerationY:Float(pEmitter:Int) "win32"
Global pxParticleEmitGetTDAccelerationZ:Float(pEmitter:Int) "win32"
Global pxParticleEmitGetScaleFactorRadius:Float(pEmitter:Int) "win32"
Global pxParticleEmitGetScaleFactorRate:Float(pEmitter:Int) "win32"
Global pxParticleEmitGetNumberParticles:Int(pEmitter:Int) "win32"

Global pxParticleEmitAddParticle:Int(pEmitter:Int, entity:Int) "win32"
Global pxParticleEmitDelete(pEmitter:Int) "win32"
Global pxParticleUpdateEmitter(pEmitter:Int) "win32"
Global pxParticleGetEntity:Int(particle:Int) "win32"
Global pxParticleGetBody:Int(particle:Int) "win32"
Global pxParticleGetradius:Float(particle:Int) "win32"


' Joint
Global pxJointCreateHinge:Int(body1:Int, body2:Int, X:Float, Y:Float, Z:Float, nx:Float, ny:Float, nz:Float) "win32"
Global pxJointCreateSpherical:Int(body1:Int, body2:Int, X:Float, Y:Float, Z:Float, nx:Float, ny:Float, nz:Float) "win32"
Global pxJointCreateDistance:Int(body1:Int, body2:Int, p1_x:Float, p1_y:Float, p1_z:Float, p2_x:Float, p2_y:Float, p2_z:Float) "win32"
Global pxJointCreateFixed:Int(body1:Int, body2:Int) "win32"
Global pxJointCreateCylindrical:Int(body1:Int, body2:Int, X:Float, Y:Float, Z:Float, nx:Float, ny:Float, nz:Float, minv_limit:Float, maxv_limit:Float) "win32"
Global pxJointCreatePrismatic:Int(body1:Int, body2:Int, X:Float, Y:Float, Z:Float, nx:Float, ny:Float, nz:Float, minv_limit:Float, maxv_limit:Float) "win32"
Global pxJointCreateOnLine:Int(body1:Int, X:Float, Y:Float, Z:Float, nx:Float, ny:Float, nz:Float) "win32"
Global pxJointCreateInPlane:Int(body1:Int, X:Float, Y:Float, Z:Float, nx:Float, ny:Float, nz:Float) "win32"
Global pxJointCreatePulley:Int(body1:Int, body2:Int, distance:Float, stiff:Float, k_ratio:Float) "win32"
  
Global pxJointCreateD6Joint:Int(body1:Int, body2:Int, X:Float, Y:Float, Z:Float, nx:Float, ny:Float, nz:Float) "win32"
Global pxD6JointSetPosMotion(joint:Int, xMot:Int, yMot:Int, zMot:Int) "win32"
Global pxD6JointSetAngleMotion(joint:Int, twistMot:Int, swing1Mot:Int, swing2Mot:Int) "win32"
Global pxD6JointSetLinearLimit(joint:Int, lim:Float) "win32"
Global pxD6JointSetSwingLimit(joint:Int, swing1Lim:Float, swing2Lim:Float) "win32"
Global pxD6JointSetTwistLimit(joint:Int, lowLim:Float, heighLim:Float) "win32"
  
Global pxJointHingeSetLimit(joint:Int, minv:Float, maxv:Float) "win32"
Global pxJointHingeSetSpring(joint:Int, spr:Float, targetVal:Float) "win32"
Global pxJointSphericalSetLimitAngle(joint:Int, angle:Float, hardn:Float, restit:Float) "win32"
Global pxJointSphericalSetLimitTwist(joint:Int, minvtwist:Float, maxvtwist:Float, spr:Float, damp:Float, targetVal:Float) "win32"
Global pxJointSphericalSetLimitSpring(joint:Int, spr:Float, damp:Float, targetVal:Float) "win32"
Global pxJointDistanceSetPoint(joint:Int, minvdist:Float, maxvdist:Float) "win32"
Global pxJointDistanceSetSpring(joint:Int, spr:Float, damp:Float) "win32"
Global pxJointAddLimitPlane(joint:Int, X:Float, Y:Float, Z:Float, nx:Float, ny:Float, nz:Float) "win32"
Global pxJointPulleySetAnchor(joint:Int, x1:Float, y1:Float, z1:Float, x2:Float, y2:Float, z2:Float) "win32"
Global pxJointPulleySetLocalAttachBody(joint:Int, x1:Float, y1:Float, z1:Float, x2:Float, y2:Float, z2:Float) "win32"
Global pxJointHingeSetMotor(joint:Int, force:Float, velTarget:Float) "win32"
Global pxJointSetBreakable(joint:Int, force:Float, torque:Float) "win32"
Global pxJointIsBroken:Int(joint:Int) "win32"
Global pxJointHingeSetCollision(joint:Int) "win32"
Global pxJointSphericalSetCollision(joint:Int) "win32"
Global pxJointDistanceSetCollision(joint:Int) "win32"
Global pxJointCylindricalSetCollision(joint:Int) "win32"

Global pxDeleteJoint(joint:Int) "win32"

' Whell (RayCast)
Global pxWheelAddToBody:Int(body:Int, pos_x:Float, pos_y:Float, pos_z:Float) "win32"
Global pxWheelSetRadius(wheel:Int, radius:Float) "win32"
Global pxWheelSetRotation(wheel:Int, Pitch:Float, Yaw:Float, Roll:Float) "win32"
Global pxWheelSetMotorTorque(wheel:Int, torque:Float) "win32"
Global pxWheelSetSteerAngle(wheel:Int, angle:Float) "win32"
Global pxWheelSetBrakeTorque(wheel:Int, torque:Float) "win32"
Global pxWheelSetSuspension(wheel:Int, susp:Float, rest:Float, damping:Float) "win32"
Global pxWheelSetFrictionToSide(wheel:Int, friction:Float) "win32"
Global pxWheelSetFrictionToFront(wheel:Int, friction:Float) "win32"
Global pxWheelSetCollisionGroup(wheel:Int, group:Int) "win32"
  
Global pxWheelGetSteerAngle:Float(wheel:Int) "win32"
Global pxWheelGetAxleSpeed:Float(wheel:Int) "win32"
Global pxWheelGetRadius:Float(wheel:Int) "win32"
Global pxWheelGetSuspensionTravel:Float(wheel:Int) "win32"
Global pxWheelGetSuspensionRestitution:Float(wheel:Int) "win32"
Global pxWheelGetSuspensionDamping:Float(wheel:Int) "win32"
  
Global pxWheelGetPositionX:Float(wheel:Int) "win32"
Global pxWheelGetPositionY:Float(wheel:Int) "win32"
Global pxWheelGetPositionZ:Float(wheel:Int) "win32"
Global pxWheelUpdateSpec(wheel:Int, mode:Int) "win32"
Global pxWheelGetPositionXSpec:Float(wheel:Int) "win32"
Global pxWheelGetPositionYSpec:Float(wheel:Int) "win32"
Global pxWheelGetPositionZSpec:Float(wheel:Int) "win32"
Global pxWheelGetRotationPitchSpec:Float(wheel:Int) "win32"
Global pxWheelGetRotationYawSpec:Float(wheel:Int) "win32"
Global pxWheelGetRotationRollSpec:Float(wheel:Int) "win32"
  
Global pxWheelGetContactX:Float(wheel:Int) "win32"
Global pxWheelGetContactY:Float(wheel:Int) "win32"
Global pxWheelGetContactZ:Float(wheel:Int) "win32"
Global pxWheelGetContactForce:Float(wheel:Int) "win32"
Global pxWheelGetContactLatDirectionX:Float(wheel:Int) "win32"
Global pxWheelGetContactLatDirectionY:Float(wheel:Int) "win32"
Global pxWheelGetContactLatDirectionZ:Float(wheel:Int) "win32"
Global pxWheelGetContactLatImpulse:Float(wheel:Int) "win32"
Global pxWheelGetContactLonDirectionX:Float(wheel:Int) "win32"
Global pxWheelGetContactLonDirectionY:Float(wheel:Int) "win32"
Global pxWheelGetContactLonDirectionZ:Float(wheel:Int) "win32"
Global pxWheelGetContactLonImpulse:Float(wheel:Int) "win32"
Global pxWheelGetContactMaterial:Int(wheel:Int) "win32"
Global pxWheelGetFrictionToSide:Float(wheel:Int) "win32"
Global pxWheelGetFrictionToFront:Float(wheel:Int) "win32"
  
Global pxWheelSetMask(wheel:Int, mask:Int) "win32"
Global pxWheelSetMaskCombine(wheel:Int, mask:Int) "win32"
Global pxWheelClearMask(wheel:Int) "win32"
Global pxWheelDelete(wheel:Int) "win32"
Global pxWheelSetEntity:Float(entity:Int, wheel:Int, Steps:Int) "win32"


' Spring
Global pxCreateSpringAndDamperEffector:Int(body1:Int, body2:Int) "win32"
Global pxSetLinearSpring(spring:Int, SpringRelaxed:Float, CompressForce:Float, CompressSaturate:Float, StretchForce:Float, StretchSaturate:Float) "win32"
Global pxSetLinearDamper(spring:Int, CompressForce:Float, CompressSaturate:Float, StretchForce:Float, StretchSaturate:Float) "win32"
Global pxDeleteEffector(effector:Int) "win32"

' Joint Suspension
Global pxJointCreateSuspFront:Int(body0:Int, body1:Int, X:Float, Y:Float, Z:Float) "win32"
Global pxJointCreateSuspBack:Int(body0:Int, body1:Int, X:Float, Y:Float, Z:Float) "win32"
Global pxJointSuspSetSteerN(joint:Int, X:Float, Y:Float, Z:Float) "win32"
Global pxJointSuspSetTurnN(joint:Int, X:Float, Y:Float, Z:Float) "win32"
Global pxJointSuspSetLinLimit(joint:Int, lim:Float) "win32"
Global pxJointSuspSetLinParameter(joint:Int, spring:Float, rest:Float, damp:Float) "win32"
Global pxJointSuspSetAngLimit(joint:Int, lim:Float) "win32"
Global pxJointSuspSetAngParameter(joint:Int, spring:Float, rest:Float, damp:Float) "win32"
Global pxJointSuspSetAngle(joint:Int, angle:Float) "win32"
Global pxJointSuspSetSpeed(joint:Int, speed:Float) "win32"
Global pxJointSuspSetBrake(joint:Int, mode:Int) "win32"


' Temp
Global peeksint:Int(addr:Int) "win32"

Global pxGetAngleBetweenVec:Float(v1x:Float, v1y:Float, v1z:Float, v2x:Float, v2y:Float, v2z:Float) "win32"

Global pxBodyGetRotationQuatX:Float(body:Int) "win32"
Global pxBodyGetRotationQuatY:Float(body:Int) "win32"
Global pxBodyGetRotationQuatZ:Float(body:Int) "win32"
Global pxBodyGetRotationQuatW:Float(body:Int) "win32"


' Library
If lib:Int
	pxBodyCreatePlane = GetProcAddress(lib, "_pxBodyCreatePlane@12") 
	pxBodyCreateCube = GetProcAddress(lib, "_pxBodyCreateCube@16") 
	pxBodyCreateSphere = GetProcAddress(lib, "_pxBodyCreateSphere@8") 
	pxBodyCreateCapsule = GetProcAddress(lib, "_pxBodyCreateCapsule@12") 
	pxBodyCreateCylinder = GetProcAddress(lib, "_pxBodyCreateCylinder@16") 
	pxBodyCreateHull = GetProcAddress(lib, "_pxBodyCreateHull@12") 
	pxBodyCreateHullFromSSM = GetProcAddress(lib, "_pxBodyCreateHullFromSSM@8") 
	
	pxCreateTriMeshPmap = GetProcAddress(lib, "_pxCreateTriMeshPmap@24") 
	pxCreateTriMeshFromPmap = GetProcAddress(lib, "_pxCreateTriMeshFromPmap@8") 
	pxCreateTriMesh = GetProcAddress(lib, "_pxCreateTriMesh@20") 
	pxCreateTerrain = GetProcAddress(lib, "_pxCreateTerrain@20") 
	pxCreateTerrainFromMesh = GetProcAddress(lib, "_pxCreateTerrainFromMesh@20") 
	pxCreateTerrainPmap = GetProcAddress(lib, "_pxCreateTerrainPmap@28") 
	pxTestTriMesh = GetProcAddress(lib, "_pxTestTriMesh@8") 
	pxCreateTriMeshToFile = GetProcAddress(lib, "_pxCreateTriMeshToFile@20") 
	pxCreateTriMeshFromFile = GetProcAddress(lib, "_pxCreateTriMeshFromFile@8") 
	
	
	pxCreateForceField = GetProcAddress(lib, "_pxCreateForceField@0") 
	pxForceFieldUpdate = GetProcAddress(lib, "_pxForceFieldUpdate@4") 
	pxForceFieldGetConstant = GetProcAddress(lib, "_pxForceFieldGetConstant@4") 
	
	
	pxShapesGetNumber = GetProcAddress(lib, "_pxShapesGetNumber@4")
	pxShapesGetShape = GetProcAddress(lib, "_pxShapesGetShape@8")
	pxShapesGetPositionX = GetProcAddress(lib, "_pxShapesGetPositionX@4")
	pxShapesGetPositionY = GetProcAddress(lib, "_pxShapesGetPositionY@4")
	pxShapesGetPositionZ = GetProcAddress(lib, "_pxShapesGetPositionZ@4")
	pxShapesGetRotationPitch = GetProcAddress(lib, "_pxShapesGetRotationPitch@4")
	pxShapesGetRotationYaw = GetProcAddress(lib, "_pxShapesGetRotationYaw@4")
	pxShapesGetRotationRoll = GetProcAddress(lib, "_pxShapesGetRotationRoll@4")
	pxShapesSetPosition = GetProcAddress(lib, "_pxShapesSetPosition@16")
	pxShapesSetRotation = GetProcAddress(lib, "_pxShapesSetRotation@16")
	pxContactGetShape = GetProcAddress(lib, "_pxContactGetShape@8")
	
	
	pxCreateSoftBody = GetProcAddress(lib, "_pxCreateSoftBody@40") 
	pxUpdateSoftBody = GetProcAddress(lib, "_pxUpdateSoftBody@4") 
	
	pxSoftBodyLinkMesh = GetProcAddress(lib, "_pxSoftBodyLinkMesh@12") 
	pxSoftBodyGetNumVert = GetProcAddress(lib, "_pxSoftBodyGetNumVert@4") 
	pxSoftBodyGetVertexPos = GetProcAddress(lib, "_pxSoftBodyGetVertexPos@12") 
	pxSoftBodyGetNormals = GetProcAddress(lib, "_pxSoftBodyGetNormals@12") 
	pxSoftBodyIsSleeping = GetProcAddress(lib, "_pxSoftBodyIsSleeping@4") 
	pxSoftBodyPutToSleep = GetProcAddress(lib, "_pxSoftBodyPutToSleep@4") 
	pxSoftBodyWakeUp = GetProcAddress(lib, "_pxSoftBodyWakeUp@8") 
	
	pxSoftBodySetAttachmentResponseCoefficient = GetProcAddress(lib, "_pxSoftBodySetAttachmentResponseCoefficient@8") 
	pxSoftBodySetAttachmentTearFactor = GetProcAddress(lib, "_pxSoftBodySetAttachmentTearFactor@8") 
	pxSoftBodySetCollisionResponseCoefficient = GetProcAddress(lib, "_pxSoftBodySetCollisionResponseCoefficient@8") 
	pxSoftBodySetDampingCoefficient = GetProcAddress(lib, "_pxSoftBodySetDampingCoefficient@8") 
	pxSoftBodySetExternalAcceleration = GetProcAddress(lib, "_pxSoftBodySetExternalAcceleration@16") 
	pxSoftBodySetFriction = GetProcAddress(lib, "_pxSoftBodySetFriction@8") 
	pxSoftBodySetLinkRadius = GetProcAddress(lib, "_pxSoftBodySetLinkRadius@4") 
	pxSoftBodySetMask = GetProcAddress(lib, "_pxSoftBodySetMask@8") 
	pxSoftBodySetMaskCombine = GetProcAddress(lib, "_pxSoftBodySetMaskCombine@8") 
	pxSoftBodyMaskClear = GetProcAddress(lib, "_pxSoftBodyMaskClear@4") 
	pxSoftBodySetName = GetProcAddress(lib, "_pxSoftBodySetName@8") 
	pxSoftBodySetParticleRadius = GetProcAddress(lib, "_pxSoftBodySetParticleRadius@8") 
	pxSoftBodySetSleepLinearVelocity = GetProcAddress(lib, "_pxSoftBodySetSleepLinearVelocity@8") 
	pxSoftBodySetSolverIterations = GetProcAddress(lib, "_pxSoftBodySetSolverIterations@8") 
	pxSoftBodySetStretchingStiffness = GetProcAddress(lib, "_pxSoftBodySetStretchingStiffness@8") 
	pxSoftBodySetVolumeStiffness = GetProcAddress(lib, "_pxSoftBodySetVolumeStiffness@8") 
	pxSoftBodySetGravity = GetProcAddress(lib, "_pxSoftBodySetGravity@8") 
	pxSoftBodySetStatic = GetProcAddress(lib, "_pxSoftBodySetStatic@8") 
	pxSoftBodySetCollision = GetProcAddress(lib, "_pxSoftBodySetCollision@8") 
	
	pxSoftBodyGetAttachmentResponseCoefficient = GetProcAddress(lib, "_pxSoftBodyGetAttachmentResponseCoefficient@4") 
	pxSoftBodyGetAttachmentTearFactor = GetProcAddress(lib, "_pxSoftBodyGetAttachmentTearFactor@4") 
	pxSoftBodyGetCollisionResponseCoefficient = GetProcAddress(lib, "_pxSoftBodyGetCollisionResponseCoefficient@4") 
	pxSoftBodyGetDampingCoefficient = GetProcAddress(lib, "_pxSoftBodyGetDampingCoefficient@4") 
	pxSoftBodyGetFriction = GetProcAddress(lib, "_pxSoftBodyGetFriction@4") 
	pxSoftBodyGetName = GetProcAddress(lib, "_pxSoftBodyGetName@4") 
	pxSoftBodyGetParticleRadius = GetProcAddress(lib, "_pxSoftBodyGetParticleRadius@4") 
	pxSoftBodyGetSleepLinearVelocity = GetProcAddress(lib, "_pxSoftBodyGetSleepLinearVelocity@4") 
	pxSoftBodyGetSolverIterations = GetProcAddress(lib, "_pxSoftBodyGetSolverIterations@4") 
	pxSoftBodyGetStretchingStiffness = GetProcAddress(lib, "_pxSoftBodyGetStretchingStiffness@4") 
	pxSoftBodyGetVolumeStiffness = GetProcAddress(lib, "_pxSoftBodyGetVolumeStiffness@4") 
	
	pxSoftBodyAttachToShape = GetProcAddress(lib, "_pxSoftBodyAttachToShape@12") 
	pxSoftBodyAttachToCollidingShapes = GetProcAddress(lib, "_pxSoftBodyAttachToCollidingShapes@8") 
	pxSoftBodyDetachFromShape = GetProcAddress(lib, "_pxSoftBodyDetachFromShape@8") 
	pxSoftBodyAttachVertexToGlobalPosition = GetProcAddress(lib, "_pxSoftBodyAttachVertexToGlobalPosition@20") 
	pxSoftBodyFreeVertex = GetProcAddress(lib, "_pxSoftBodyFreeVertex@8") 
	pxSoftBodyAddForceAtPos = GetProcAddress(lib, "_pxSoftBodyAddForceAtPos@28") 
	pxSoftBodyAddForceAtVertex = GetProcAddress(lib, "_pxSoftBodyAddForceAtVertex@24") 
	
	
	pxIrrGetPosMat = GetProcAddress(lib, "_pxIrrGetPosMat@8") 
	pxIrrGetPosElem = GetProcAddress(lib, "_pxIrrGetPosElem@4") 
	pxIrrGetRotElem = GetProcAddress(lib, "_pxIrrGetRotElem@4") 
	
	pxParticleCreateEmitter = GetProcAddress(lib, "_pxParticleCreateEmitter@0") 
	pxParticleEmitSetAngDamping = GetProcAddress(lib, "_pxParticleEmitSetAngDamping@8") 
	pxParticleEmitSetLinDamping = GetProcAddress(lib, "_pxParticleEmitSetLinDamping@8") 
	pxParticleEmitSetMass = GetProcAddress(lib, "_pxParticleEmitSetMass@8") 
	pxParticleEmitSetRadius = GetProcAddress(lib, "_pxParticleEmitSetRadius@8") 
	pxParticleEmitSetPosition = GetProcAddress(lib, "_pxParticleEmitSetPosition@16") 
	pxParticleEmitSetRotation = GetProcAddress(lib, "_pxParticleEmitSetRotation@16") 
	pxParticleEmitSetRandRadius = GetProcAddress(lib, "_pxParticleEmitSetRandRadius@8") 
	pxParticleEmitSetStartSpeed = GetProcAddress(lib, "_pxParticleEmitSetStartSpeed@12") 
	pxParticleEmitSetTDAcceleration = GetProcAddress(lib, "_pxParticleEmitSetTDAcceleration@16") 
	pxParticleEmitSetScaleFactor = GetProcAddress(lib, "_pxParticleEmitSetScaleFactor@12") 
	pxParticleEmitDeleteFirstParticle = GetProcAddress(lib, "_pxParticleEmitDeleteFirstParticle@4") 
	pxParticleEmitDeleteParticle = GetProcAddress(lib, "_pxParticleEmitDeleteParticle@8") 
	
	pxParticleEmitGetAngDamping = GetProcAddress(lib, "_pxParticleEmitGetAngDamping@4") 
	pxParticleEmitGetLinDamping = GetProcAddress(lib, "_pxParticleEmitGetLinDamping@4") 
	pxParticleEmitGetMass = GetProcAddress(lib, "_pxParticleEmitGetMass@4") 
	pxParticleEmitGetRadius = GetProcAddress(lib, "_pxParticleEmitGetRadius@4") 
	pxParticleEmitGetPositionX = GetProcAddress(lib, "_pxParticleEmitGetPositionX@4") 
	pxParticleEmitGetPositionY = GetProcAddress(lib, "_pxParticleEmitGetPositionY@4") 
	pxParticleEmitGetPositionZ = GetProcAddress(lib, "_pxParticleEmitGetPositionZ@4") 
	pxParticleEmitGetRotationPitch = GetProcAddress(lib, "_pxParticleEmitGetRotationPitch@4") 
	pxParticleEmitGetRotationYaw = GetProcAddress(lib, "_pxParticleEmitGetRotationYaw@4") 
	pxParticleEmitGetRotationRoll = GetProcAddress(lib, "_pxParticleEmitGetRotationRoll@4") 
	pxParticleEmitGetRandRadius = GetProcAddress(lib, "_pxParticleEmitGetRandRadius@4") 
	pxParticleEmitGetStartSpeedMax = GetProcAddress(lib, "_pxParticleEmitGetStartSpeedMax@4") 
	pxParticleEmitGetStartSpeedMin = GetProcAddress(lib, "_pxParticleEmitGetStartSpeedMin@4") 
	pxParticleEmitGetTDAccelerationX = GetProcAddress(lib, "_pxParticleEmitGetTDAccelerationX@4") 
	pxParticleEmitGetTDAccelerationY = GetProcAddress(lib, "_pxParticleEmitGetTDAccelerationY@4") 
	pxParticleEmitGetTDAccelerationZ = GetProcAddress(lib, "_pxParticleEmitGetTDAccelerationZ@4") 
	pxParticleEmitGetScaleFactorRadius = GetProcAddress(lib, "_pxParticleEmitGetScaleFactorRadius@4") 
	pxParticleEmitGetScaleFactorRate = GetProcAddress(lib, "_pxParticleEmitGetScaleFactorRate@4") 
	pxParticleEmitGetNumberParticles = GetProcAddress(lib, "_pxParticleEmitGetNumberParticles@4") 
	
	pxParticleEmitAddParticle = GetProcAddress(lib, "_pxParticleEmitAddParticle@8") 
	pxParticleEmitDelete = GetProcAddress(lib, "_pxParticleEmitDelete@4") 
	pxParticleUpdateEmitter = GetProcAddress(lib, "_pxParticleUpdateEmitter@4") 
	pxParticleGetEntity = GetProcAddress(lib, "_pxParticleGetEntity@4") 
	pxParticleGetBody = GetProcAddress(lib, "_pxParticleGetBody@4") 
	pxParticleGetradius = GetProcAddress(lib, "_pxParticleGetradius@4") 
	
	
	pxKinematicSet = GetProcAddress(lib, "_pxKinematicSet@4") 
	pxKinematicClear = GetProcAddress(lib, "_pxKinematicClear@4") 
	pxKinematicMove = GetProcAddress(lib, "_pxKinematicMove@16") 
	pxKinematicSetPosition = GetProcAddress(lib, "_pxKinematicSetPosition@16") 
	pxKinematicSetRotation = GetProcAddress(lib, "_pxKinematicSetRotation@16") 
	
	
	pxCreateMagnet = GetProcAddress(lib, "_pxCreateMagnet@12") 
	pxMagnetActivate = GetProcAddress(lib, "_pxMagnetActivate@12") 
	pxMagnetSetPosition = GetProcAddress(lib, "_pxMagnetSetPosition@16") 
	pxMagnetSetMaxRadius = GetProcAddress(lib, "_pxMagnetSetMaxRadius@8") 
	pxMagnetSetMinRadius = GetProcAddress(lib, "_pxMagnetSetMinRadius@8") 
	pxMagnetSetMaxForce = GetProcAddress(lib, "_pxMagnetSetMaxForce@8") 
	pxMagnetSetMidForce = GetProcAddress(lib, "_pxMagnetSetMidForce@8") 
	pxMagnetSetMinForce = GetProcAddress(lib, "_pxMagnetSetMinForce@8") 
	pxMagnetSetMask = GetProcAddress(lib, "_pxMagnetSetMask@8") 
	pxMagnetGetPositionX = GetProcAddress(lib, "_pxMagnetGetPositionX@4") 
	pxMagnetGetPositionY = GetProcAddress(lib, "_pxMagnetGetPositionY@4") 
	pxMagnetGetPositionZ = GetProcAddress(lib, "_pxMagnetGetPositionZ@4") 
	pxMagnetGetMaxRadius = GetProcAddress(lib, "_pxMagnetGetMaxRadius@4") 
	pxMagnetGetMinRadius = GetProcAddress(lib, "_pxMagnetGetMinRadius@4") 
	pxMagnetGetMaxForce = GetProcAddress(lib, "_pxMagnetGetMaxForce@4") 
	pxMagnetGetMidForce = GetProcAddress(lib, "_pxMagnetGetMidForce@4") 
	pxMagnetGetMinForce = GetProcAddress(lib, "_pxMagnetGetMinForce@4") 
	pxMagnetGetMask = GetProcAddress(lib, "_pxMagnetGetMask@4") 
	pxMagnetDelete = GetProcAddress(lib, "_pxMagnetDelete@4") 
	
	
	pxCreateWaterCirPlane = GetProcAddress(lib, "_pxCreateWaterCirPlane@8") 
	pxCreateWaterRectPlane = GetProcAddress(lib, "_pxCreateWaterRectPlane@12") 
	pxCreateWaterInfinPlane = GetProcAddress(lib, "_pxCreateWaterInfinPlane@4") 
	pxWaterSetDimension = GetProcAddress(lib, "_pxWaterSetDimension@12") 
	pxWaterSetRadius = GetProcAddress(lib, "_pxWaterSetRadius@8") 
	pxWaterSetPosition = GetProcAddress(lib, "_pxWaterSetPosition@16") 
	pxWaterSetRotation = GetProcAddress(lib, "_pxWaterSetRotation@8") 
	pxWaterSetFluxion = GetProcAddress(lib, "_pxWaterSetFluxion@16") 
	pxWaterGetWidth = GetProcAddress(lib, "_pxWaterGetWidth@4") 
	pxWaterGetHeight = GetProcAddress(lib, "_pxWaterGetHeight@4") 
	pxWaterGetRadius = GetProcAddress(lib, "_pxWaterGetRadius@4") 
	pxWaterGetPositionX = GetProcAddress(lib, "_pxWaterGetPositionX@4") 
	pxWaterGetPositionY = GetProcAddress(lib, "_pxWaterGetPositionY@4") 
	pxWaterGetPositionZ = GetProcAddress(lib, "_pxWaterGetPositionZ@4") 
	pxWaterGetRotation = GetProcAddress(lib, "_pxWaterGetRotation@4") 
	pxWaterGetDepth = GetProcAddress(lib, "_pxWaterGetDepth@4") 
	pxWaterDelete = GetProcAddress(lib, "_pxWaterDelete@4") 
	
	pxCreateKep = GetProcAddress(lib, "_pxCreateKep@12") 
	pxKepAddToBody = GetProcAddress(lib, "_pxKepAddToBody@8") 
	pxKepSetLocalPosition = GetProcAddress(lib, "_pxKepSetLocalPosition@16") 
	pxKepSetGlobalPosition = GetProcAddress(lib, "_pxKepSetGlobalPosition@16") 
	pxKepSetAngularDamping = GetProcAddress(lib, "_pxKepSetAngularDamping@8") 
	pxKepSetLinearDamping = GetProcAddress(lib, "_pxKepSetLinearDamping@8") 
	pxWaterUpdate = GetProcAddress(lib, "_pxWaterUpdate@4") 
	pxKepGetPosX = GetProcAddress(lib, "_pxKepGetPosX@4") 
	pxKepGetPosY = GetProcAddress(lib, "_pxKepGetPosY@4") 
	pxKepGetPosZ = GetProcAddress(lib, "_pxKepGetPosZ@4") 
	pxKepGetNumber = GetProcAddress(lib, "_pxKepGetNumber@4") 
	pxKepGetKepFromBody = GetProcAddress(lib, "_pxKepGetKepFromBody@8") 
	
	
	pxTriggerCreateCube = GetProcAddress(lib, "_pxTriggerCreateCube@12") 
	pxTriggerCreateSphere = GetProcAddress(lib, "_pxTriggerCreateSphere@4") 
	pxTriggerCreateCapsule = GetProcAddress(lib, "_pxTriggerCreateCapsule@8") 
	pxTriggerCreateCylinder = GetProcAddress(lib, "_pxTriggerCreateCylinder@12") 
	pxTriggerCreateHull = GetProcAddress(lib, "_pxTriggerCreateHull@8") 
	pxTriggerSetPosition = GetProcAddress(lib, "_pxTriggerSetPosition@16") 
	pxTriggerSetRotation = GetProcAddress(lib, "_pxTriggerSetRotation@16") 
	pxTriggerGetNumBody = GetProcAddress(lib, "_pxTriggerGetNumBody@4") 
	pxTriggerGetBody = GetProcAddress(lib, "_pxTriggerGetBody@8") 
	pxTriggerGetBodyTrigger = GetProcAddress(lib, "_pxTriggerGetBodyTrigger@4") 
	pxUpdateTriggers = GetProcAddress(lib, "_pxUpdateTriggers@0") 
	
	
	pxCreateCompoundDesc = GetProcAddress(lib, "_pxCreateCompoundDesc@0") 
	pxCompoundAddCubeShape = GetProcAddress(lib, "_pxCompoundAddCubeShape@16") 
	pxCompoundAddSphereShape = GetProcAddress(lib, "_pxCompoundAddSphereShape@8") 
	pxCompoundAddCapsuleShape = GetProcAddress(lib, "_pxCompoundAddCapsuleShape@12") 
	pxCompoundAddCylinderShape = GetProcAddress(lib, "_pxCompoundAddCylinderShape@16") 
	pxCompoundAddHullShape = GetProcAddress(lib, "_pxCompoundAddHullShape@12") 
	pxCompoundSetShapePos = GetProcAddress(lib, "_pxCompoundSetShapePos@16") 
	pxCompoundSetShapeRot = GetProcAddress(lib, "_pxCompoundSetShapeRot@16") 
	pxCreateCompound = GetProcAddress(lib, "_pxCreateCompound@8") 
	pxCreateStaticCompound = GetProcAddress(lib, "_pxCreateStaticCompound@8") 
	
	
	pxCreateCloth = GetProcAddress(lib, "_pxCreateCloth@8") 
	pxCreateTearableCloth = GetProcAddress(lib, "_pxCreateTearableCloth@8") 
	pxCreateMetalCloth = GetProcAddress(lib, "_pxCreateMetalCloth@20") 
	pxCreateClothSpec = GetProcAddress(lib, "_pxCreateClothSpec@16") 
	pxCreateMetalClothSpec = GetProcAddress(lib, "_pxCreateMetalClothSpec@28") 
	
	pxClothGetAttachmentResponseCoefficient = GetProcAddress(lib, "_pxClothGetAttachmentResponseCoefficient@4") 
	pxClothGetAttachmentTearFactor = GetProcAddress(lib, "_pxClothGetAttachmentTearFactor@4") 
	pxClothGetBendingStiffness = GetProcAddress(lib, "_pxClothGetBendingStiffness@4") 
	pxClothGetCollisionResponseCoefficient = GetProcAddress(lib, "_pxClothGetCollisionResponseCoefficient@4") 
	pxClothGetDampingCoefficient = GetProcAddress(lib, "_pxClothGetDampingCoefficient@4") 
	pxClothGetDensity = GetProcAddress(lib, "_pxClothGetDensity@4") 
	pxClothGetFriction = GetProcAddress(lib, "_pxClothGetFriction@4") 
	pxClothGetPressure = GetProcAddress(lib, "_pxClothGetPressure@4") 
	pxClothGetSleepLinearVelocity = GetProcAddress(lib, "_pxClothGetSleepLinearVelocity@4") 
	pxClothGetStretchingStiffness = GetProcAddress(lib, "_pxClothGetStretchingStiffness@4") 
	pxClothGetTearFactor = GetProcAddress(lib, "_pxClothGetTearFactor@4") 
	pxClothGetThickness = GetProcAddress(lib, "_pxClothGetThickness@4") 
	pxClothGetNumVertices = GetProcAddress(lib, "_pxClothGetNumVertices@4") 
	pxClothIsSleeping = GetProcAddress(lib, "_pxClothIsSleeping@4") 
	pxClothGetEntity = GetProcAddress(lib, "_pxClothGetEntity@4") 
	pxClothGetUserData = GetProcAddress(lib, "_pxClothGetUserData@4") 
	pxClothPutToSleep = GetProcAddress(lib, "_pxClothPutToSleep@4") 
	pxClothWakeUp = GetProcAddress(lib, "_pxClothWakeUp@4") 
	pxClothSetGravity = GetProcAddress(lib, "_pxClothSetGravity@8") 
	
	pxClothSetTeareble = GetProcAddress(lib, "_pxClothSetTeareble@4") 
	pxClothSetTearFactor = GetProcAddress(lib, "_pxClothSetTearFactor@8") 
	
	pxClothSetAttachmentResponseCoefficient = GetProcAddress(lib, "_pxClothSetAttachmentResponseCoefficient@8") 
	pxClothSetAttachmentTearFactor = GetProcAddress(lib, "_pxClothSetAttachmentTearFactor@8") 
	pxClothSetBending = GetProcAddress(lib, "_pxClothSetBending@4") 
	pxClothSetBendingStiffness = GetProcAddress(lib, "_pxClothSetBendingStiffness@8") 
	pxClothSetCollisionResponseCoefficient = GetProcAddress(lib, "_pxClothSetCollisionResponseCoefficient@8") 
	pxClothSetDampingCoefficient = GetProcAddress(lib, "_pxClothSetDampingCoefficient@8") 
	pxClothSetComDampingCoefficient = GetProcAddress(lib, "_pxClothSetComDampingCoefficient@8") 
	pxClothSetFriction = GetProcAddress(lib, "_pxClothSetFriction@8") 
	pxClothSetPressure = GetProcAddress(lib, "_pxClothSetPressure@8") 
	pxClothSetSleepLinearVelocity = GetProcAddress(lib, "_pxClothSetSleepLinearVelocity@8") 
	pxClothSetStretchingStiffness = GetProcAddress(lib, "_pxClothSetStretchingStiffness@8") 
	pxClothSetThickness = GetProcAddress(lib, "_pxClothSetThickness@8") 
	pxClothSetUserData = GetProcAddress(lib, "_pxClothSetUserData@8") 
	pxClothMaskSet = GetProcAddress(lib, "_pxClothMaskSet@8") 
	pxClothMaskCombineSet = GetProcAddress(lib, "_pxClothMaskCombineSet@8") 
	
	pxClothSetVertexPos = GetProcAddress(lib, "_pxClothSetVertexPos@12") 
	pxClothGetVertexPos = GetProcAddress(lib, "_pxClothGetVertexPos@12") 
	pxClothGetNormals = GetProcAddress(lib, "_pxClothGetNormals@8") 
	
	pxClothAttachVertexToPos = GetProcAddress(lib, "_pxClothAttachVertexToPos@20") 
	pxClothAttachToCollidingShapes = GetProcAddress(lib, "_pxClothAttachToCollidingShapes@8") 
	pxClothAttachToCore = GetProcAddress(lib, "_pxClothAttachToCore@16") 
	pxClothAttachToShape = GetProcAddress(lib, "_pxClothAttachToShape@12") 
	pxClothDetachFromShape = GetProcAddress(lib, "_pxClothDetachFromShape@8") 
	pxClothFreeVertex = GetProcAddress(lib, "_pxClothFreeVertex@8") 
	pxClothAddForceAtPos = GetProcAddress(lib, "_pxClothAddForceAtPos@24") 
	pxClothAddForceAtVertex = GetProcAddress(lib, "_pxClothAddForceAtVertex@20") 
	pxUpdateCloth = GetProcAddress(lib, "_pxUpdateCloth@0") 
	pxClothDelete = GetProcAddress(lib, "_pxClothDelete@4") 
	
	pxClothGetTearVertex = GetProcAddress(lib, "_pxClothGetTearVertex@8")
	pxClothGetTearIndices = GetProcAddress(lib, "_pxClothGetTearIndices@8")
	pxClothGetTearPIndices = GetProcAddress(lib, "_pxClothGetTearPIndices@8")
	pxClothGetNumTearVertex = GetProcAddress(lib, "_pxClothGetNumTearVertex@4")
	pxClothGetNumTearTris = GetProcAddress(lib, "_pxClothGetNumTearTris@4")
	
	
	pxCreateSpringAndDamperEffector = GetProcAddress(lib, "_pxCreateSpringAndDamperEffector@8") 
	pxSetLinearSpring = GetProcAddress(lib, "_pxSetLinearSpring@24") 
	pxSetLinearDamper = GetProcAddress(lib, "_pxSetLinearDamper@20") 
	pxDeleteEffector = GetProcAddress(lib, "_pxDeleteEffector@4") 
	
	
	pxWheelAddToBody = GetProcAddress(lib, "_pxWheelAddToBody@16") 
	pxWheelSetRadius = GetProcAddress(lib, "_pxWheelSetRadius@8") 
	pxWheelSetRotation = GetProcAddress(lib, "_pxWheelSetRotation@16") 
	pxWheelSetMotorTorque = GetProcAddress(lib, "_pxWheelSetMotorTorque@8") 
	pxWheelSetSteerAngle = GetProcAddress(lib, "_pxWheelSetSteerAngle@8") 
	pxWheelSetBrakeTorque = GetProcAddress(lib, "_pxWheelSetBrakeTorque@8") 
	pxWheelSetSuspension = GetProcAddress(lib, "_pxWheelSetSuspension@16") 
	pxWheelSetFrictionToSide = GetProcAddress(lib, "_pxWheelSetFrictionToSide@8") 
	pxWheelSetFrictionToFront = GetProcAddress(lib, "_pxWheelSetFrictionToFront@8") 
	pxWheelSetCollisionGroup = GetProcAddress(lib, "_pxWheelSetCollisionGroup@8") 
	
	pxWheelGetSteerAngle = GetProcAddress(lib, "_pxWheelGetSteerAngle@4") 
	pxWheelGetAxleSpeed = GetProcAddress(lib, "_pxWheelGetAxleSpeed@4") 
	pxWheelGetRadius = GetProcAddress(lib, "_pxWheelGetRadius@4") 
	pxWheelGetSuspensionTravel = GetProcAddress(lib, "_pxWheelGetSuspensionTravel@4") 
	pxWheelGetSuspensionRestitution = GetProcAddress(lib, "_pxWheelGetSuspensionRestitution@4") 
	pxWheelGetSuspensionDamping = GetProcAddress(lib, "_pxWheelGetSuspensionDamping@4") 
	
	pxWheelGetPositionX = GetProcAddress(lib, "_pxWheelGetPositionX@4") 
	pxWheelGetPositionY = GetProcAddress(lib, "_pxWheelGetPositionY@4") 
	pxWheelGetPositionZ = GetProcAddress(lib, "_pxWheelGetPositionZ@4") 
	pxWheelUpdateSpec = GetProcAddress(lib, "_pxWheelUpdateSpec@8") 
	pxWheelGetPositionXSpec = GetProcAddress(lib, "_pxWheelGetPositionXSpec@4") 
	pxWheelGetPositionYSpec = GetProcAddress(lib, "_pxWheelGetPositionYSpec@4") 
	pxWheelGetPositionZSpec = GetProcAddress(lib, "_pxWheelGetPositionZSpec@4") 
	pxWheelGetRotationPitchSpec = GetProcAddress(lib, "_pxWheelGetRotationPitchSpec@4") 
	pxWheelGetRotationYawSpec = GetProcAddress(lib, "_pxWheelGetRotationYawSpec@4") 
	pxWheelGetRotationRollSpec = GetProcAddress(lib, "_pxWheelGetRotationRollSpec@4") 
	
	pxWheelGetContactX = GetProcAddress(lib, "_pxWheelGetContactX@4") 
	pxWheelGetContactY = GetProcAddress(lib, "_pxWheelGetContactY@4") 
	pxWheelGetContactZ = GetProcAddress(lib, "_pxWheelGetContactZ@4") 
	pxWheelGetContactForce = GetProcAddress(lib, "_pxWheelGetContactForce@4") 
	pxWheelGetContactLatDirectionX = GetProcAddress(lib, "_pxWheelGetContactLatDirectionX@4") 
	pxWheelGetContactLatDirectionY = GetProcAddress(lib, "_pxWheelGetContactLatDirectionY@4") 
	pxWheelGetContactLatDirectionZ = GetProcAddress(lib, "_pxWheelGetContactLatDirectionZ@4") 
	pxWheelGetContactLatImpulse = GetProcAddress(lib, "_pxWheelGetContactLatImpulse@4") 
	pxWheelGetContactLonDirectionX = GetProcAddress(lib, "_pxWheelGetContactLonDirectionX@4") 
	pxWheelGetContactLonDirectionY = GetProcAddress(lib, "_pxWheelGetContactLonDirectionY@4") 
	pxWheelGetContactLonDirectionZ = GetProcAddress(lib, "_pxWheelGetContactLonDirectionZ@4") 
	pxWheelGetContactLonImpulse = GetProcAddress(lib, "_pxWheelGetContactLonImpulse@4") 
	pxWheelGetContactMaterial = GetProcAddress(lib, "_pxWheelGetContactMaterial@4") 
	pxWheelGetFrictionToSide = GetProcAddress(lib, "_pxWheelGetFrictionToSide@4") 
	pxWheelGetFrictionToFront = GetProcAddress(lib, "_pxWheelGetFrictionToFront@4") 
	
	pxWheelSetMask = GetProcAddress(lib, "_pxWheelSetMask@8") 
	pxWheelSetMaskCombine = GetProcAddress(lib, "_pxWheelSetMaskCombine@8") 
	pxWheelClearMask = GetProcAddress(lib, "_pxWheelClearMask@4") 
	pxWheelDelete = GetProcAddress(lib, "_pxWheelDelete@4") 
	pxWheelSetEntity = GetProcAddress(lib, "_pxWheelSetEntity@12") 
	
	
	pxJointCreateSuspFront = GetProcAddress(lib, "_pxJointCreateSuspFront@20") 
	pxJointCreateSuspBack = GetProcAddress(lib, "_pxJointCreateSuspBack@20") 
	pxJointSuspSetSteerN = GetProcAddress(lib, "_pxJointSuspSetSteerN@16") 
	pxJointSuspSetTurnN = GetProcAddress(lib, "_pxJointSuspSetTurnN@16") 
	pxJointSuspSetLinLimit = GetProcAddress(lib, "_pxJointSuspSetLinLimit@8") 
	pxJointSuspSetLinParameter = GetProcAddress(lib, "_pxJointSuspSetLinParameter@16") 
	pxJointSuspSetAngLimit = GetProcAddress(lib, "_pxJointSuspSetAngLimit@8") 
	pxJointSuspSetAngParameter = GetProcAddress(lib, "_pxJointSuspSetAngParameter@16") 
	pxJointSuspSetAngle = GetProcAddress(lib, "_pxJointSuspSetAngle@8") 
	pxJointSuspSetSpeed = GetProcAddress(lib, "_pxJointSuspSetSpeed@8") 
	pxJointSuspSetBrake = GetProcAddress(lib, "_pxJointSuspSetBrake@8") 
	
	
	pxCCDSkeletonEnable = GetProcAddress(lib, "_pxCCDSkeletonEnable@4") 
	pxCCDSkeletonSetEpsilon = GetProcAddress(lib, "_pxCCDSkeletonSetEpsilon@4") 
	pxBodySetCCDSkeleton = GetProcAddress(lib, "_pxBodySetCCDSkeleton@16") 
	pxBodySetCCDSkeletonThreshold = GetProcAddress(lib, "_pxBodySetCCDSkeletonThreshold@8") 
	pxBodySetFlagCCDSkeletonDynamic = GetProcAddress(lib, "_pxBodySetFlagCCDSkeletonDynamic@4") 
	pxBodyGetCCDSkeleton = GetProcAddress(lib, "_pxBodyGetCCDSkeleton@4") 
	pxBodyDeleteCCDSkeleton = GetProcAddress(lib, "_pxBodyDeleteCCDSkeleton@4") 
	
	
	pxCreateRay = GetProcAddress(lib, "_pxCreateRay@0") 
	pxRaySetDir = GetProcAddress(lib, "_pxRaySetDir@16") 
	pxRaySetPosition = GetProcAddress(lib, "_pxRaySetPosition@16") 
	pxRayGetDistance = GetProcAddress(lib, "_pxRayGetDistance@8") 
	pxRayGetBody = GetProcAddress(lib, "_pxRayGetBody@8") 
	pxRayGetMaterial = GetProcAddress(lib, "_pxRayGetMaterial@8") 
	pxRayGetPickX = GetProcAddress(lib, "_pxRayGetPickX@8") 
	pxRayGetPickY = GetProcAddress(lib, "_pxRayGetPickY@8") 
	pxRayGetPickZ = GetProcAddress(lib, "_pxRayGetPickZ@8") 
	pxRayGetPickNX = GetProcAddress(lib, "_pxRayGetPickNX@8") 
	pxRayGetPickNY = GetProcAddress(lib, "_pxRayGetPickNY@8") 
	pxRayGetPickNZ = GetProcAddress(lib, "_pxRayGetPickNZ@8") 
	
	
	pxRegWriteDriverPath = GetProcAddress(lib, "_pxRegWriteDriverPath@4") 
	pxRegWriteString = GetProcAddress(lib, "_pxRegWriteString@16") 
	pxRegWriteInt = GetProcAddress(lib, "_pxRegWriteInt@16") 
	pxRegReadInt = GetProcAddress(lib, "_pxRegReadInt@12") 
	pxRegReadString = GetProcAddress(lib, "_pxRegReadString@12") 
	pxRegDeleteValue = GetProcAddress(lib, "_pxRegDeleteValue@12") 
	pxRegDeleteKey = GetProcAddress(lib, "_pxRegDeleteKey@12") 
	
	
	pxGetContacts = GetProcAddress(lib, "_pxGetContacts@4") 
	pxContactGetBody = GetProcAddress(lib, "_pxContactGetBody@8") 
	pxContactGetPointX = GetProcAddress(lib, "_pxContactGetPointX@8") 
	pxContactGetPointY = GetProcAddress(lib, "_pxContactGetPointY@8") 
	pxContactGetPointZ = GetProcAddress(lib, "_pxContactGetPointZ@8") 
	pxContactGetPointNX = GetProcAddress(lib, "_pxContactGetPointNX@8") 
	pxContactGetPointNY = GetProcAddress(lib, "_pxContactGetPointNY@8") 
	pxContactGetPointNZ = GetProcAddress(lib, "_pxContactGetPointNZ@8") 
	pxContactGetForceN = GetProcAddress(lib, "_pxContactGetForceN@8") 
	pxContactGetForceNX = GetProcAddress(lib, "_pxContactGetForceNX@8") 
	pxContactGetForceNY = GetProcAddress(lib, "_pxContactGetForceNY@8") 
	pxContactGetForceNZ = GetProcAddress(lib, "_pxContactGetForceNZ@8") 
	pxContactGetForceT = GetProcAddress(lib, "_pxContactGetForceT@8") 
	pxContactGetForceTX = GetProcAddress(lib, "_pxContactGetForceTX@8") 
	pxContactGetForceTY = GetProcAddress(lib, "_pxContactGetForceTY@8") 
	pxContactGetForceTZ = GetProcAddress(lib, "_pxContactGetForceTZ@8") 
	pxContactEventsOnStartTouch = GetProcAddress(lib, "_pxContactEventsOnStartTouch@4") 
	pxContactEventsOnEndTouch = GetProcAddress(lib, "_pxContactEventsOnEndTouch@4") 
	
	
	pxMaskSet = GetProcAddress(lib, "_pxMaskSet@8") 
	pxMaskCombineSet = GetProcAddress(lib, "_pxMaskCombineSet@8") 
	pxMaskClear = GetProcAddress(lib, "_pxMaskClear@4") 
	pxBodySetCollisionGroup = GetProcAddress(lib, "_pxBodySetCollisionGroup@8") 
	pxBodySetCollisionGroupPair = GetProcAddress(lib, "_pxBodySetCollisionGroupPair@8") 
	pxBodySetCollisionGroupFlag = GetProcAddress(lib, "_pxBodySetCollisionGroupFlag@12") 
	pxBodySetMagnetMask = GetProcAddress(lib, "_pxBodySetMagnetMask@8") 
	pxBodyGetMagnetMask = GetProcAddress(lib, "_pxBodyGetMagnetMask@4") 
	
	
	pxBodySetFrozen = GetProcAddress(lib, "_pxBodySetFrozen@8") 
	pxBodySetFrozenRotX = GetProcAddress(lib, "_pxBodySetFrozenRotX@8") 
	pxBodySetFrozenRotY = GetProcAddress(lib, "_pxBodySetFrozenRotY@8") 
	pxBodySetFrozenRotZ = GetProcAddress(lib, "_pxBodySetFrozenRotZ@8") 
	pxBodySetFrozenRot = GetProcAddress(lib, "_pxBodySetFrozenRot@8") 
	pxBodySetFrozenPosX = GetProcAddress(lib, "_pxBodySetFrozenPosX@8") 
	pxBodySetFrozenPosY = GetProcAddress(lib, "_pxBodySetFrozenPosY@8") 
	pxBodySetFrozenPosZ = GetProcAddress(lib, "_pxBodySetFrozenPosZ@8") 
	pxBodySetFrozenPos = GetProcAddress(lib, "_pxBodySetFrozenPos@8") 
	pxBodySetFlagGravity = GetProcAddress(lib, "_pxBodySetFlagGravity@8") 
	pxBodySetFlagCollision = GetProcAddress(lib, "_pxBodySetFlagCollision@8") 
	pxBodySetFlagResponse = GetProcAddress(lib, "_pxBodySetFlagResponse@8") 
	pxBodySetFlagContacttable = GetProcAddress(lib, "_pxBodySetFlagContacttable@8") 
	pxBodySetFlagMagniteble = GetProcAddress(lib, "_pxBodySetFlagMagniteble@8") 
	pxBodySetFlagTriggertable = GetProcAddress(lib, "_pxBodySetFlagTriggertable@8") 
	pxBodySetFlagRayCast = GetProcAddress(lib, "_pxBodySetFlagRayCast@8") 
	
	
	pxDeleteBody = GetProcAddress(lib, "_pxDeleteBody@4") 
	pxDeleteJoint = GetProcAddress(lib, "_pxDeleteJoint@4") 
	
	
	pxJointCreateHinge = GetProcAddress(lib, "_pxJointCreateHinge@32") 
	pxJointCreateSpherical = GetProcAddress(lib, "_pxJointCreateSpherical@32") 
	pxJointCreateDistance = GetProcAddress(lib, "_pxJointCreateDistance@32") 
	pxJointCreateFixed = GetProcAddress(lib, "_pxJointCreateFixed@8") 
	pxJointCreateCylindrical = GetProcAddress(lib, "_pxJointCreateCylindrical@40") 
	pxJointCreatePrismatic = GetProcAddress(lib, "_pxJointCreatePrismatic@40") 
	pxJointCreateOnLine = GetProcAddress(lib, "_pxJointCreateOnLine@28") 
	pxJointCreateInPlane = GetProcAddress(lib, "_pxJointCreateInPlane@28") 
	pxJointCreatePulley = GetProcAddress(lib, "_pxJointCreatePulley@20") 
	
	pxJointCreateD6Joint = GetProcAddress(lib, "_pxJointCreateD6Joint@32") 
	pxD6JointSetPosMotion = GetProcAddress(lib, "_pxD6JointSetPosMotion@16") 
	pxD6JointSetAngleMotion = GetProcAddress(lib, "_pxD6JointSetAngleMotion@16") 
	pxD6JointSetLinearLimit = GetProcAddress(lib, "_pxD6JointSetLinearLimit@8") 
	pxD6JointSetSwingLimit = GetProcAddress(lib, "_pxD6JointSetSwingLimit@12") 
	pxD6JointSetTwistLimit = GetProcAddress(lib, "_pxD6JointSetTwistLimit@12") 
	
	pxJointHingeSetLimit = GetProcAddress(lib, "_pxJointHingeSetLimit@12") 
	pxJointHingeSetSpring = GetProcAddress(lib, "_pxJointHingeSetSpring@12") 
	pxJointSphericalSetLimitAngle = GetProcAddress(lib, "_pxJointSphericalSetLimitAngle@16") 
	pxJointSphericalSetLimitTwist = GetProcAddress(lib, "_pxJointSphericalSetLimitTwist@24") 
	pxJointSphericalSetLimitSpring = GetProcAddress(lib, "_pxJointSphericalSetLimitSpring@16") 
	pxJointDistanceSetPoint = GetProcAddress(lib, "_pxJointDistanceSetPoint@12") 
	pxJointDistanceSetSpring = GetProcAddress(lib, "_pxJointDistanceSetSpring@12") 
	pxJointAddLimitPlane = GetProcAddress(lib, "_pxJointAddLimitPlane@28") 
	pxJointPulleySetAnchor = GetProcAddress(lib, "_pxJointPulleySetAnchor@28") 
	pxJointPulleySetLocalAttachBody = GetProcAddress(lib, "_pxJointPulleySetLocalAttachBody@28") 
	pxJointHingeSetMotor = GetProcAddress(lib, "_pxJointHingeSetMotor@12") 
	pxJointSetBreakable = GetProcAddress(lib, "_pxJointSetBreakable@12") 
	pxJointIsBroken = GetProcAddress(lib, "_pxJointIsBroken@4") 
	pxJointHingeSetCollision = GetProcAddress(lib, "_pxJointHingeSetCollision@4") 
	pxJointSphericalSetCollision = GetProcAddress(lib, "_pxJointSphericalSetCollision@4") 
	pxJointDistanceSetCollision = GetProcAddress(lib, "_pxJointDistanceSetCollision@4") 
	pxJointCylindricalSetCollision = GetProcAddress(lib, "_pxJointCylindricalSetCollision@4") 
	
	
	pxSetGravity = GetProcAddress(lib, "_pxSetGravity@12") 
	pxBodySetMass = GetProcAddress(lib, "_pxBodySetMass@8") 
	pxBodySetCMassLocalPosition = GetProcAddress(lib, "_pxBodySetCMassLocalPosition@16") 
	pxBodySetCMassGlobalPosition = GetProcAddress(lib, "_pxBodySetCMassGlobalPosition@16") 
	pxBodySetMassSpaceInertiaTensor = GetProcAddress(lib, "_pxBodySetMassSpaceInertiaTensor@16") 
	pxBodyGetCMassGlobalPositionX = GetProcAddress(lib, "_pxBodyGetCMassGlobalPositionX@4") 
	pxBodyGetCMassGlobalPositionY = GetProcAddress(lib, "_pxBodyGetCMassGlobalPositionY@4") 
	pxBodyGetCMassGlobalPositionZ = GetProcAddress(lib, "_pxBodyGetCMassGlobalPositionZ@4") 
	pxBodyGetCMassLocalPositionX = GetProcAddress(lib, "_pxBodyGetCMassLocalPositionX@4") 
	pxBodyGetCMassLocalPositionY = GetProcAddress(lib, "_pxBodyGetCMassLocalPositionY@4") 
	pxBodyGetCMassLocalPositionZ = GetProcAddress(lib, "_pxBodyGetCMassLocalPositionZ@4") 
	pxBodyGetMass = GetProcAddress(lib, "_pxBodyGetMass@4") 
	
	
	pxBodySetMyForce = GetProcAddress(lib, "_pxBodySetMyForce@16") 
	pxBodyAddForce = GetProcAddress(lib, "_pxBodyAddForce@20") 
	pxBodyAddForceAtPos = GetProcAddress(lib, "_pxBodyAddForceAtPos@32") 
	pxBodyAddForceAtLocalPos = GetProcAddress(lib, "_pxBodyAddForceAtLocalPos@32") 
	pxBodyAddLocalForce = GetProcAddress(lib, "_pxBodyAddLocalForce@20") 
	pxBodyAddLocalForceAtPos = GetProcAddress(lib, "_pxBodyAddLocalForceAtPos@32") 
	pxBodyAddLocalForceAtLocalPos = GetProcAddress(lib, "_pxBodyAddLocalForceAtLocalPos@32") 
	
	pxBodyAddTorque = GetProcAddress(lib, "_pxBodyAddTorque@20") 
	pxBodyAddLocalTorque = GetProcAddress(lib, "_pxBodyAddLocalTorque@20") 
	pxBodySetAngularSpeed = GetProcAddress(lib, "_pxBodySetAngularSpeed@16") 
	pxBodySetLinearSpeed = GetProcAddress(lib, "_pxBodySetLinearSpeed@16") 
	pxBodySetLocalLinearSpeed = GetProcAddress(lib, "_pxBodySetLocalLinearSpeed@16") 
	pxBodySetLocalAngularSpeed = GetProcAddress(lib, "_pxBodySetLocalAngularSpeed@16") 
	pxBodySetAngularDamping = GetProcAddress(lib, "_pxBodySetAngularDamping@8") 
	pxBodySetLinearDamping = GetProcAddress(lib, "_pxBodySetLinearDamping@8") 
	pxBodySetAngularMomentum = GetProcAddress(lib, "_pxBodySetAngularMomentum@16") 
	pxBodySetLinearMomentum = GetProcAddress(lib, "_pxBodySetLinearMomentum@16") 
	pxBodySetMaxAngularSpeed = GetProcAddress(lib, "_pxBodySetMaxAngularSpeed@8") 
	pxBodySetSleepEnergyThreshold = GetProcAddress(lib, "_pxBodySetSleepEnergyThreshold@8") 
	pxBodySetSleepAngularVelocity = GetProcAddress(lib, "_pxBodySetSleepAngularVelocity@8") 
	pxBodySetSleepLinearVelocity = GetProcAddress(lib, "_pxBodySetSleepLinearVelocity@8") 
	pxBodySetSleepWakeUp = GetProcAddress(lib, "_pxBodySetSleepWakeUp@8") 
	pxBodySetSleepPut = GetProcAddress(lib, "_pxBodySetSleepPut@4") 
	pxBodySetSolverIterationCount = GetProcAddress(lib, "_pxBodySetSolverIterationCount@8") 
	pxBodySetName = GetProcAddress(lib, "_pxBodySetBodyName@8") 
	pxBodySetEntity = GetProcAddress(lib, "_pxBodySetBodyEntity@8") 
	pxBodySetUserData = GetProcAddress(lib, "_pxBodySetBodyUserData@8") 
	pxMoveBodyToPoint = GetProcAddress(lib, "_pxMoveBodyToPoint@20") 
	pxAddBodytoBody = GetProcAddress(lib, "_pxAddBodytoBody@8") 
	pxCopyBody = GetProcAddress(lib, "_pxCopyBody@4") 
	
	
	pxCreateMaterial = GetProcAddress(lib, "_pxCreateMaterial@0") 
	pxMaterialSetToBody = GetProcAddress(lib, "_pxMaterialSetToBody@8") 
	pxMaterialSetRestitution = GetProcAddress(lib, "_pxMaterialSetRestitution@8") 
	pxMaterialSetRestitutionCombineMode = GetProcAddress(lib, "_pxMaterialSetRestitutionCombineMode@8") 
	pxMaterialSetStFriction = GetProcAddress(lib, "_pxMaterialSetStFriction@8") 
	pxMaterialSetDyFriction = GetProcAddress(lib, "_pxMaterialSetDyFriction@8") 
	pxMaterialSetFrictionV = GetProcAddress(lib, "_pxMaterialSetFrictionV@12") 
	pxMaterialSetFrictionCombineMode = GetProcAddress(lib, "_pxMaterialSetFrictionCombineMode@8") 
	pxCreateAnisotripicMaterial = GetProcAddress(lib, "_pxCreateAnisotripicMaterial@12") 
	pxMaterialSetFlagStrongFriction = GetProcAddress(lib, "_pxMaterialSetFlagStrongFriction@4") 
	pxGetMaterial = GetProcAddress(lib, "_pxGetMaterial@4") 
	
	
	pxBodySetPosition = GetProcAddress(lib, "_pxBodySetPosition@16") 
	pxBodySetRotation = GetProcAddress(lib, "_pxBodySetRotation@16") 
	
	pxBodyGetPositionX = GetProcAddress(lib, "_pxBodyGetPositionX@4") 
	pxBodyGetPositionY = GetProcAddress(lib, "_pxBodyGetPositionY@4") 
	pxBodyGetPositionZ = GetProcAddress(lib, "_pxBodyGetPositionZ@4") 
	pxBodyGetRotationPitch = GetProcAddress(lib, "_pxBodyGetRotationPitch@4") 
	pxBodyGetRotationYaw = GetProcAddress(lib, "_pxBodyGetRotationYaw@4") 
	pxBodyGetRotationRoll = GetProcAddress(lib, "_pxBodyGetRotationRoll@4") 
	pxBodyGetAngularSpeed = GetProcAddress(lib, "_pxBodyGetAngularSpeed@4") 
	pxBodyGetAngularSpeedX = GetProcAddress(lib, "_pxBodyGetAngularSpeedX@4") 
	pxBodyGetAngularSpeedY = GetProcAddress(lib, "_pxBodyGetAngularSpeedY@4") 
	pxBodyGetAngularSpeedZ = GetProcAddress(lib, "_pxBodyGetAngularSpeedZ@4") 
	pxBodyGetLocalAngularSpeedX = GetProcAddress(lib, "_pxBodyGetLocalAngularSpeedX@4") 
	pxBodyGetLocalAngularSpeedY = GetProcAddress(lib, "_pxBodyGetLocalAngularSpeedY@4") 
	pxBodyGetLocalAngularSpeedZ = GetProcAddress(lib, "_pxBodyGetLocalAngularSpeedZ@4") 
	pxBodyGetLinearSpeed = GetProcAddress(lib, "_pxBodyGetLinearSpeed@4") 
	pxBodyGetLinearSpeedX = GetProcAddress(lib, "_pxBodyGetLinearSpeedX@4") 
	pxBodyGetLinearSpeedY = GetProcAddress(lib, "_pxBodyGetLinearSpeedY@4") 
	pxBodyGetLinearSpeedZ = GetProcAddress(lib, "_pxBodyGetLinearSpeedZ@4") 
	pxBodyGetLocalLinearSpeedX = GetProcAddress(lib, "_pxBodyGetLocalLinearSpeedX@4") 
	pxBodyGetLocalLinearSpeedY = GetProcAddress(lib, "_pxBodyGetLocalLinearSpeedY@4") 
	pxBodyGetLocalLinearSpeedZ = GetProcAddress(lib, "_pxBodyGetLocalLinearSpeedZ@4") 
	pxBodyGetLinearVecSpeedX = GetProcAddress(lib, "_pxBodyGetLinearVecSpeedX@4") 
	pxBodyGetLinearVecSpeedY = GetProcAddress(lib, "_pxBodyGetLinearVecSpeedY@4") 
	pxBodyGetLinearVecSpeedZ = GetProcAddress(lib, "_pxBodyGetLinearVecSpeedZ@4") 
	pxBodyGetLocalPointSpeed = GetProcAddress(lib, "_pxBodyGetLocalPointSpeed@12") 
	pxBodyGetLocalPointSpeedX = GetProcAddress(lib, "_pxBodyGetLocalPointSpeedX@12") 
	pxBodyGetLocalPointSpeedY = GetProcAddress(lib, "_pxBodyGetLocalPointSpeedY@12") 
	pxBodyGetLocalPointSpeedZ = GetProcAddress(lib, "_pxBodyGetLocalPointSpeedZ@12") 
	
	
	pxBodyGetAngularDamping = GetProcAddress(lib, "_pxBodyGetAngularDamping@4") 
	pxBodyGetLinearDamping = GetProcAddress(lib, "_pxBodyGetLinearDamping@4") 
	pxBodyGetAngularMomentum = GetProcAddress(lib, "_pxBodyGetAngularMomentum@4") 
	pxBodyGetLinearMomentum = GetProcAddress(lib, "_pxBodyGetLinearMomentum@4") 
	pxBodyGetMaxAngularVelocity = GetProcAddress(lib, "_pxBodyGetMaxAngularVelocity@4") 
	pxBodyGetName = GetProcAddress(lib, "_pxGetBodyName@4") 
	pxBodyGetEntity = GetProcAddress(lib, "_pxGetBodyEntity@4") 
	pxBodyGetUserData = GetProcAddress(lib, "_pxGetBodyUserData@4") 
	pxBodyGetSleepAngularVelocity = GetProcAddress(lib, "_pxBodyGetSleepAngularVelocity@4") 
	pxBodyGetSleepLinearVelocity = GetProcAddress(lib, "_pxBodyGetSleepLinearVelocity@4") 
	pxBodyIsDynamic = GetProcAddress(lib, "_pxBodyIsDynamic@4") 
	pxBodyIsSleeping = GetProcAddress(lib, "_pxBodyIsSleeping@4") 
	
	
	pxGetNumberAllBody = GetProcAddress(lib, "_pxGetNumberAllBody@0") 
	pxCreateWorld = GetProcAddress(lib, "_pxCreateWorld@8") 
	PxCreateWorldWithoutDrivers = GetProcAddress(lib, "_pxCreateWorldWithoutDrivers@8") 
	pxDestroyWorld = GetProcAddress(lib, "_pxDestroyWorld@0") 
	pxRenderPhysic = GetProcAddress(lib, "_pxRenderPhysic@8") 
	pxSetTiming = GetProcAddress(lib, "_pxSetTiming@12") 
	pxSDKSetParameter = GetProcAddress(lib, "_pxSDKSetParameter@4") 
	pxSetPause = GetProcAddress(lib, "_pxSetPause@4") 
	pxChekPPU = GetProcAddress(lib, "_pxChekPPU@0") 
	pxChekPPUMode = GetProcAddress(lib, "_pxChekPPUMode@0") 
	pxSetHardwareSimulation = GetProcAddress(lib, "_pxSetHardwareSimulation@4")
	pxDriverSetMode = GetProcAddress(lib, "_pxDriverSetMode@4")
	
	pxCreateScene = GetProcAddress(lib, "_pxCreateScene@0") 
	pxSceneChange = GetProcAddress(lib, "_pxSceneChange@4") 
	
	
	pxBodySetEntity = GetProcAddress(lib, "_pxBodySetEntity@8") 
	pxBodyAddEntity = GetProcAddress(lib, "_pxBodyAddEntity@8") 
	pxDX9BodySetEntity = GetProcAddress(lib, "_pxDX9BodySetEntity@8") 
	
	pxBufferCreate = GetProcAddress(lib, "_pxBufferCreate@4") 
	pxBufferSetElement = GetProcAddress(lib, "_pxBufferSetElement@12") 
	pxBufferGetElement = GetProcAddress(lib, "_pxBufferGetElement@8") 
	pxBufferDelete = GetProcAddress(lib, "_pxBufferDelete@4") 
	
	peeksint = GetProcAddress(lib, "_peeksint@4") 
	
	pxGetAngleBetweenVec = GetProcAddress(lib, "_pxGetAngleBetweenVec@24") 
	
	pxBodyGetRotationQuatX = GetProcAddress(lib, "_pxBodyGetRotationQuatX@4") 
	pxBodyGetRotationQuatY = GetProcAddress(lib, "_pxBodyGetRotationQuatY@4") 
	pxBodyGetRotationQuatZ = GetProcAddress(lib, "_pxBodyGetRotationQuatZ@4") 
	pxBodyGetRotationQuatW = GetProcAddress(lib, "_pxBodyGetRotationQuatW@4") 
Else
	End
EndIf