#define PXDECL extern "C" __declspec(dllimport)
#define PXCALL __stdcall

PXDECL int   PXCALL pxBodyCreatePlane(float x, float y, float z);
PXDECL int   PXCALL pxBodyCreateCube(float dx, float dy, float dz, float mass);
PXDECL int   PXCALL pxBodyCreateSphere(float radius, float mass);
PXDECL int   PXCALL pxBodyCreateCapsule(float height, float radius, float mass);
PXDECL int   PXCALL pxBodyCreateCylinder(float radius, float height, int nbEdge, float mass);
PXDECL int   PXCALL pxBodyCreateHull(float* vbank, int nvert, float mass);
PXDECL int   PXCALL pxBodyCreateHullFromSSM(int surf, float mass);

PXDECL int   PXCALL pxCreateTriMeshPmap(int vbank, int fbank, int MESH_NBVERTICES, int MESH_NBFACES, char* file_name, int pMap);
PXDECL int   PXCALL pxCreateTriMeshFromPmap(int triangleMesh, float mass);
PXDECL int   PXCALL pxCreateTriMesh(float* vbank, int* fbank, int MESH_NBVERTICES, int MESH_NBFACES, float mass);
PXDECL int   PXCALL pxCreateTerrain(int nSize, int bank, float scale_x, float scale_y, float scale_z);
PXDECL int   PXCALL pxCreateTerrainFromMesh(int vbank, int fbank, int MESH_NBVERTICES, int MESH_NBFACES, float axis);
PXDECL void  PXCALL pxCreateTerrainPmap(int vbank, int fbank, int MESH_NBVERTICES, int MESH_NBFACES, float axis, char* file_name, int pMap);
PXDECL int   PXCALL pxTestTriMesh(int entity, float mass);
PXDECL int   PXCALL pxCreateTriMeshToFile(int vbank, int fbank, int MESH_NBVERTICES, int MESH_NBFACES, char* fname);
PXDECL int   PXCALL pxCreateTriMeshFromFile(char* fname, float mass);


PXDECL int   PXCALL pxCreateForceField();
PXDECL void  PXCALL pxForceFieldUpdate(int FField);
PXDECL float PXCALL pxForceFieldGetConstant(int FField);



PXDECL int   PXCALL pxCreateSoftBody(char* OBJfile, char* TETfile, int vbank, int numVert, float pos_x, float pos_y, float pos_z, float rot_x, float rot_y, float rot_z);
PXDECL void  PXCALL pxUpdateSoftBody(int SB);

PXDECL void  PXCALL pxSoftBodyLinkMesh(int softBody, int vbank, int numVert);
PXDECL int   PXCALL pxSoftBodyGetNumVert(int SB);
PXDECL void  PXCALL pxSoftBodyGetVertexPos(int SB, int vbank, int numVert);
PXDECL void  PXCALL pxSoftBodyGetNormals(int SB, int nbank, int numVert);
PXDECL int   PXCALL pxSoftBodyIsSleeping(int SB);
PXDECL void  PXCALL pxSoftBodyPutToSleep(int SB);
PXDECL void  PXCALL pxSoftBodyWakeUp(int SB, int interval);

PXDECL void  PXCALL pxSoftBodySetAttachmentResponseCoefficient(int softBody, float coef);
PXDECL void  PXCALL pxSoftBodySetAttachmentTearFactor(int softBody, float coef);
PXDECL void  PXCALL pxSoftBodySetCollisionResponseCoefficient(int softBody, float coef);
PXDECL void  PXCALL pxSoftBodySetDampingCoefficient(int softBody, float coef);
PXDECL void  PXCALL pxSoftBodySetExternalAcceleration(int softBody, float x, float y, float z);
PXDECL void  PXCALL pxSoftBodySetFriction(int softBody, float fric);
PXDECL void  PXCALL pxSoftBodySetLinkRadius(float radius);
PXDECL void  PXCALL pxSoftBodySetMask(int softBody, int mask);
PXDECL void  PXCALL pxSoftBodySetMaskCombine(int softBody, int mask);
PXDECL void  PXCALL pxSoftBodyMaskClear(int softBody);
PXDECL void  PXCALL pxSoftBodySetName(int softBody, char* name);
PXDECL void  PXCALL pxSoftBodySetParticleRadius(int softBody, float radius);
PXDECL void  PXCALL pxSoftBodySetSleepLinearVelocity(int softBody, float vel);
PXDECL void  PXCALL pxSoftBodySetSolverIterations(int softBody, int iter);
PXDECL void  PXCALL pxSoftBodySetStretchingStiffness(int softBody, float coef);
PXDECL void  PXCALL pxSoftBodySetVolumeStiffness(int softBody, float coef);
PXDECL void  PXCALL pxSoftBodySetGravity(int softBody, int stat);
PXDECL void  PXCALL pxSoftBodySetStatic(int softBody, int stat);
PXDECL void  PXCALL pxSoftBodySetCollision(int softBody, int stat);

PXDECL float PXCALL pxSoftBodyGetAttachmentResponseCoefficient(int softBody);
PXDECL float PXCALL pxSoftBodyGetAttachmentTearFactor(int softBody);
PXDECL float PXCALL pxSoftBodyGetCollisionResponseCoefficient(int softBody);
PXDECL float PXCALL pxSoftBodyGetDampingCoefficient(int softBody);
PXDECL float PXCALL pxSoftBodyGetFriction(int softBody);
PXDECL char* PXCALL pxSoftBodyGetName(int softBody);
PXDECL float PXCALL pxSoftBodyGetParticleRadius(int softBody);
PXDECL float PXCALL pxSoftBodyGetSleepLinearVelocity(int softBody);
PXDECL int   PXCALL pxSoftBodyGetSolverIterations(int softBody);
PXDECL float PXCALL pxSoftBodyGetStretchingStiffness(int softBody);
PXDECL float PXCALL pxSoftBodyGetVolumeStiffness(int softBody);

PXDECL void  PXCALL pxSoftBodyAttachToShape(int softBody, int body, int flag);
PXDECL void  PXCALL pxSoftBodyAttachToCollidingShapes(int softBody, int tearable);
PXDECL void  PXCALL pxSoftBodyDetachFromShape(int softBody, int body);
PXDECL void  PXCALL pxSoftBodyAttachVertexToGlobalPosition(int softBody, int vertID, float x, float y, float z);
PXDECL void  PXCALL pxSoftBodyFreeVertex(int softBody, int vertID);
PXDECL void  PXCALL pxSoftBodyAddForceAtPos(int softBody, float pos_x, float pos_y, float pos_z, float magnitude, float radius, int mode);
PXDECL void  PXCALL pxSoftBodyAddForceAtVertex(int softBody, float x, float y, float z, int vertID, int mode);


PXDECL void  PXCALL pxIrrGetPosMat(int body, int irrMat);
PXDECL float PXCALL pxIrrGetPosElem(int body);
PXDECL float PXCALL pxIrrGetRotElem(int body);

PXDECL int   PXCALL pxParticleCreateEmitter();
PXDECL void  PXCALL pxParticleEmitSetAngDamping(int pEmitter, int damp);
PXDECL void  PXCALL pxParticleEmitSetLinDamping(int pEmitter, int damp);
PXDECL void  PXCALL pxParticleEmitSetMass(int pEmitter, float mass);
PXDECL void  PXCALL pxParticleEmitSetRadius(int pEmitter, float radius);
PXDECL void  PXCALL pxParticleEmitSetPosition(int pEmitter, float x, float y, float z);
PXDECL void  PXCALL pxParticleEmitSetRotation(int pEmitter, float pitch, float yaw, float roll);
PXDECL void  PXCALL pxParticleEmitSetRandRadius(int pEmitter, float radius);
PXDECL void  PXCALL pxParticleEmitSetStartSpeed(int pEmitter, float min, float max);
PXDECL void  PXCALL pxParticleEmitSetTDAcceleration(int pEmitter, float x, float y, float z);
PXDECL void  PXCALL pxParticleEmitSetScaleFactor(int pEmitter, float radius, float rate);
PXDECL int   PXCALL pxParticleEmitDeleteFirstParticle(int pEmitter);
PXDECL void  PXCALL pxParticleEmitDeleteParticle(int pEmitter, int particle);

PXDECL float PXCALL pxParticleEmitGetAngDamping(int pEmitter);
PXDECL float PXCALL pxParticleEmitGetLinDamping(int pEmitter);
PXDECL float PXCALL pxParticleEmitGetMass(int pEmitter);
PXDECL float PXCALL pxParticleEmitGetRadius(int pEmitter);
PXDECL float PXCALL pxParticleEmitGetPositionX(int pEmitter);
PXDECL float PXCALL pxParticleEmitGetPositionY(int pEmitter);
PXDECL float PXCALL pxParticleEmitGetPositionZ(int pEmitter);
PXDECL float PXCALL pxParticleEmitGetRotationPitch(int pEmitter);
PXDECL float PXCALL pxParticleEmitGetRotationYaw(int pEmitter);
PXDECL float PXCALL pxParticleEmitGetRotationRoll(int pEmitter);
PXDECL float PXCALL pxParticleEmitGetRandRadius(int pEmitter);
PXDECL float PXCALL pxParticleEmitGetStartSpeedMax(int pEmitter);
PXDECL float PXCALL pxParticleEmitGetStartSpeedMin(int pEmitter);
PXDECL float PXCALL pxParticleEmitGetTDAccelerationX(int pEmitter);
PXDECL float PXCALL pxParticleEmitGetTDAccelerationY(int pEmitter);
PXDECL float PXCALL pxParticleEmitGetTDAccelerationZ(int pEmitter);
PXDECL float PXCALL pxParticleEmitGetScaleFactorRadius(int pEmitter);
PXDECL float PXCALL pxParticleEmitGetScaleFactorRate(int pEmitter);
PXDECL int   PXCALL pxParticleEmitGetNumberParticles(int pEmitter);

PXDECL int   PXCALL pxParticleEmitAddParticle(int pEmitter, int entity);
PXDECL void  PXCALL pxParticleEmitDelete(int pEmitter);
PXDECL void  PXCALL pxParticleUpdateEmitter(int pEmitter);
PXDECL int   PXCALL pxParticleGetEntity(int particle);
PXDECL int   PXCALL pxParticleGetBody(int particle);
PXDECL float PXCALL pxParticleGetradius(int particle);


PXDECL void  PXCALL pxKinematicSet(int body);
PXDECL void  PXCALL pxKinematicClear(int body);
PXDECL void  PXCALL pxKinematicMove(int body, float x, float y, float z);
PXDECL void  PXCALL pxKinematicSetPosition(int body, float x, float y, float z);
PXDECL void  PXCALL pxKinematicSetRotation(int body, float pitch, float yaw, float roll);


PXDECL int   PXCALL pxCreateMagnet(float minforce, float middleforce, float maxforce);
PXDECL void  PXCALL pxMagnetActivate(int mdata, int mmode, int fmode);
PXDECL void  PXCALL pxMagnetSetPosition(int mdata, float pos_x, float pos_y, float pos_z);
PXDECL void  PXCALL pxMagnetSetMaxRadius(int mdata, float radius);
PXDECL void  PXCALL pxMagnetSetMinRadius(int mdata, float radius);
PXDECL void  PXCALL pxMagnetSetMaxForce(int mdata, float force);
PXDECL void  PXCALL pxMagnetSetMidForce(int mdata, float force);
PXDECL void  PXCALL pxMagnetSetMinForce(int mdata, float force);
PXDECL void  PXCALL pxMagnetSetMask(int mdata, int mask);
PXDECL float PXCALL pxMagnetGetPositionX(int mdata);
PXDECL float PXCALL pxMagnetGetPositionY(int mdata);
PXDECL float PXCALL pxMagnetGetPositionZ(int mdata);
PXDECL float PXCALL pxMagnetGetMaxRadius(int mdata);
PXDECL float PXCALL pxMagnetGetMinRadius(int mdata);
PXDECL float PXCALL pxMagnetGetMaxForce(int mdata);
PXDECL float PXCALL pxMagnetGetMidForce(int mdata);
PXDECL float PXCALL pxMagnetGetMinForce(int mdata);
PXDECL int   PXCALL pxMagnetGetMask(int mdata);
PXDECL void  PXCALL pxMagnetDelete(int mdata);


PXDECL int   PXCALL pxCreateWaterCirPlane(float radius, float depth);
PXDECL int   PXCALL pxCreateWaterRectPlane(float width, float height, float depth);
PXDECL int   PXCALL pxCreateWaterInfinPlane(float depth);
PXDECL void  PXCALL pxWaterSetDimension(int water, float width, float height);
PXDECL void  PXCALL pxWaterSetRadius(int water, float radius);
PXDECL void  PXCALL pxWaterSetPosition(int water, float pos_x, float pos_y, float pos_z);
PXDECL void  PXCALL pxWaterSetRotation(int water, float angle);
PXDECL void  PXCALL pxWaterSetFluxion(int water, float fl_x, float fl_y, float fl_z);
PXDECL float PXCALL pxWaterGetWidth(int water);
PXDECL float PXCALL pxWaterGetHeight(int water);
PXDECL float PXCALL pxWaterGetRadius(int water);
PXDECL float PXCALL pxWaterGetPositionX(int water);
PXDECL float PXCALL pxWaterGetPositionY(int water);
PXDECL float PXCALL pxWaterGetPositionZ(int water);
PXDECL float PXCALL pxWaterGetRotation(int water);
PXDECL float PXCALL pxWaterGetDepth(int water);
PXDECL void  PXCALL pxWaterDelete(int water);

PXDECL int   PXCALL pxCreateKep(float buo, float radius, float maxdis);
PXDECL void  PXCALL pxKepAddToBody(int kdata, int body);
PXDECL void  PXCALL pxKepSetLocalPosition(int kdata, float pos_x, float pos_y, float pos_z);
PXDECL void  PXCALL pxKepSetGlobalPosition(int kdata, float pos_x, float pos_y, float pos_z);
PXDECL void  PXCALL pxKepSetAngularDamping(int kdata, float angdamp);
PXDECL void  PXCALL pxKepSetLinearDamping(int kdata, float lindamp);
PXDECL void  PXCALL pxWaterUpdate(int water);
PXDECL float PXCALL pxKepGetPosX(int kdata);
PXDECL float PXCALL pxKepGetPosY(int kdata);
PXDECL float PXCALL pxKepGetPosZ(int kdata);
PXDECL int   PXCALL pxKepGetNumber(int body);
PXDECL int   PXCALL pxKepGetKepFromBody(int body, int num);


PXDECL int   PXCALL pxTriggerCreateCube(float dx, float dy, float dz);
PXDECL int   PXCALL pxTriggerCreateSphere(float radius);
PXDECL int   PXCALL pxTriggerCreateCapsule(float height, float radius);
PXDECL int   PXCALL pxTriggerCreateCylinder(float radius, float height, int nbEdge);
PXDECL int   PXCALL pxTriggerCreateHull(int vbank, int nvert);
PXDECL void  PXCALL pxTriggerSetPosition(int body, float x, float y, float z);
PXDECL void  PXCALL pxTriggerSetRotation(int body, float pitch, float yaw, float roll);
PXDECL int   PXCALL pxTriggerGetNumBody(int trigger);
PXDECL int   PXCALL pxTriggerGetBody(int trigger, int num);
PXDECL int   PXCALL pxTriggerGetBodyTrigger(int body);
PXDECL void  PXCALL pxUpdateTriggers();


PXDECL int   PXCALL pxCreateCompoundDesc();
PXDECL int   PXCALL pxCompoundAddCubeShape(int compoundDesc, float dx, float dy, float dz);
PXDECL int   PXCALL pxCompoundAddSphereShape(int compoundDesc, float radius);
PXDECL int   PXCALL pxCompoundAddCapsuleShape(int compoundDesc, float radius, float height);
PXDECL int   PXCALL pxCompoundAddCylinderShape(int compoundDesc, float radius, float height, int nbEdge);
PXDECL int   PXCALL pxCompoundAddHullShape(int compoundDesc, int vbank, int nvert);
PXDECL void  PXCALL pxCompoundSetShapePos(int shape, float x, float y, float z);
PXDECL void  PXCALL pxCompoundSetShapeRot(int shape, float pitch, float yaw, float roll);
PXDECL int   PXCALL pxCreateCompound(int compoundDesc, float mass);
PXDECL int   PXCALL pxCreateStaticCompound(int compoundDesc, float mass);


PXDECL int   PXCALL pxCreateCloth(int entity, int surf);
PXDECL int   PXCALL pxCreateTearableCloth(int entity, int surf);
PXDECL int   PXCALL pxCreateMetalCloth(int entity, int surf, int coreActor, float impThr, float depth);
PXDECL int   PXCALL pxCreateClothSpec(int vbank, int fbank, int MESH_NBVERTICES, int MESH_NBFACES);
PXDECL int   PXCALL pxCreateMetalClothSpec(int vbank, int fbank, int MESH_NBVERTICES, int MESH_NBFACES, int coreActor, float impThr, float depth);

PXDECL float PXCALL pxClothGetAttachmentResponseCoefficient(int Cloth);
PXDECL float PXCALL pxClothGetAttachmentTearFactor(int Cloth);
PXDECL float PXCALL pxClothGetBendingStiffness(int Cloth);
PXDECL float PXCALL pxClothGetCollisionResponseCoefficient(int Cloth);
PXDECL float PXCALL pxClothGetDampingCoefficient(int Cloth);
PXDECL float PXCALL pxClothGetDensity(int Cloth);
PXDECL float PXCALL pxClothGetFriction(int Cloth);
PXDECL float PXCALL pxClothGetPressure(int Cloth);
PXDECL float PXCALL pxClothGetSleepLinearVelocity(int Cloth);
PXDECL float PXCALL pxClothGetStretchingStiffness(int Cloth);
PXDECL float PXCALL pxClothGetTearFactor(int Cloth);
PXDECL float PXCALL pxClothGetThickness(int Cloth);
PXDECL int   PXCALL pxClothGetNumVertices(int Cloth);
PXDECL int   PXCALL pxClothIsSleeping(int Cloth);
PXDECL int   PXCALL pxClothGetEntity(int Cloth);
PXDECL int   PXCALL pxClothGetUserData(int Cloth);
PXDECL void  PXCALL pxClothPutToSleep(int Cloth);
PXDECL void  PXCALL pxClothWakeUp(int Cloth);
PXDECL void  PXCALL pxClothSetGravity(int Cloth, int stat);

PXDECL void  PXCALL pxClothSetTeareble(int Cloth);
PXDECL void  PXCALL pxClothSetTearFactor(int Cloth, float coef);

PXDECL void PXCALL pxClothSetAttachmentResponseCoefficient(int Cloth, float coef);
PXDECL void PXCALL pxClothSetAttachmentTearFactor(int Cloth, float coef);
PXDECL void	PXCALL pxClothSetBending(int Cloth);
PXDECL void PXCALL pxClothSetBendingStiffness(int Cloth, float coef);
PXDECL void PXCALL pxClothSetCollisionResponseCoefficient(int Cloth, float coef);
PXDECL void PXCALL pxClothSetDampingCoefficient(int Cloth, float coef);
PXDECL void PXCALL pxClothSetComDampingCoefficient(int Cloth, float coef);
PXDECL void PXCALL pxClothSetFriction(int Cloth, float coef);
PXDECL void PXCALL pxClothSetPressure(int Cloth, float coef);
PXDECL void PXCALL pxClothSetSleepLinearVelocity(int Cloth, float coef);
PXDECL void PXCALL pxClothSetStretchingStiffness(int Cloth, float coef);
PXDECL void PXCALL pxClothSetThickness(int Cloth, float coef);
PXDECL void  PXCALL pxClothSetUserData(int Cloth, int userdata);
PXDECL void  PXCALL pxClothMaskSet(int Cloth, int mask);
PXDECL void  PXCALL pxClothMaskCombineSet(int Cloth, int mask);

PXDECL void  PXCALL pxClothSetVertexPos(int Cloth, int vbank, int numVert);
PXDECL void  PXCALL pxClothGetVertexPos(int Cloth, int vbank, int numVert);
PXDECL void  PXCALL pxClothGetNormals(int Cloth, int nbank);

PXDECL void  PXCALL pxClothAttachVertexToPos(int Cloth, int vID, float pos_x, float pos_y, float pos_z);
PXDECL void  PXCALL pxClothAttachToCollidingShapes(int Cloth, int flag);
PXDECL void  PXCALL pxClothAttachToCore(int Cloth, int body, float Threshold, float Depth);
PXDECL void  PXCALL pxClothAttachToShape(int Cloth, int body, int flag);
PXDECL void  PXCALL pxClothDetachFromShape(int Cloth, int body);
PXDECL void  PXCALL pxClothFreeVertex(int Cloth, int vID);
PXDECL void  PXCALL pxClothAddForceAtPos(int Cloth, float pos_x, float pos_y, float pos_z, float magnitude, float radius);
PXDECL void  PXCALL pxClothAddForceAtVertex(int Cloth, float nx, float ny, float nz, int vID);
PXDECL void  PXCALL pxUpdateCloth();
PXDECL void  PXCALL pxClothDelete(int Cloth);


PXDECL int   PXCALL pxCreateSpringAndDamperEffector(int body1, int body2);
PXDECL void  PXCALL pxSetLinearSpring(int spring, float SpringRelaxed, float CompressForce, float CompressSaturate, float StretchForce, float StretchSaturate);
PXDECL void  PXCALL pxSetLinearDamper(int spring, float CompressForce, float CompressSaturate, float StretchForce, float StretchSaturate);
PXDECL void  PXCALL pxDeleteEffector(int effector);


PXDECL int   PXCALL pxWheelAddToBody(int body, float pos_x, float pos_y, float pos_z);
PXDECL void  PXCALL pxWheelSetRadius(int wheel, float radius);
PXDECL void  PXCALL pxWheelSetRotation(int wheel, float pitch, float yaw, float roll);
PXDECL void  PXCALL pxWheelSetMotorTorque(int wheel, float torque);
PXDECL void  PXCALL pxWheelSetSteerAngle(int wheel, float angle);
PXDECL void  PXCALL pxWheelSetBrakeTorque(int wheel, float torque);
PXDECL void  PXCALL pxWheelSetSuspension(int wheel, float susp, float rest, float damping);
PXDECL void  PXCALL pxWheelSetFrictionToSide(int wheel, float friction);
PXDECL void  PXCALL pxWheelSetFrictionToFront(int wheel, float friction);
PXDECL void  PXCALL pxWheelSetCollisionGroup(int wheel, int group);

PXDECL float PXCALL pxWheelGetSteerAngle(int wheel);
PXDECL float PXCALL pxWheelGetAxleSpeed(int wheel);
PXDECL float PXCALL pxWheelGetRadius(int wheel);
PXDECL float PXCALL pxWheelGetSuspensionTravel(int wheel);
PXDECL float PXCALL pxWheelGetSuspensionRestitution(int wheel);
PXDECL float PXCALL pxWheelGetSuspensionDamping(int wheel);

PXDECL float PXCALL pxWheelGetPositionX(int wheel);
PXDECL float PXCALL pxWheelGetPositionY(int wheel);
PXDECL float PXCALL pxWheelGetPositionZ(int wheel);
PXDECL void  PXCALL pxWheelUpdateSpec(int wheel, int mode);
PXDECL float PXCALL pxWheelGetPositionXSpec(int wheel);
PXDECL float PXCALL pxWheelGetPositionYSpec(int wheel);
PXDECL float PXCALL pxWheelGetPositionZSpec(int wheel);
PXDECL float PXCALL pxWheelGetRotationPitchSpec(int wheel);
PXDECL float PXCALL pxWheelGetRotationYawSpec(int wheel);
PXDECL float PXCALL pxWheelGetRotationRollSpec(int wheel);

PXDECL float PXCALL pxWheelGetContactX(int wheel);
PXDECL float PXCALL pxWheelGetContactY(int wheel);
PXDECL float PXCALL pxWheelGetContactZ(int wheel);
PXDECL float PXCALL pxWheelGetContactForce(int wheel);
PXDECL float PXCALL pxWheelGetContactLatDirectionX(int wheel);
PXDECL float PXCALL pxWheelGetContactLatDirectionY(int wheel);
PXDECL float PXCALL pxWheelGetContactLatDirectionZ(int wheel);
PXDECL float PXCALL pxWheelGetContactLatImpulse(int wheel);
PXDECL float PXCALL pxWheelGetContactLonDirectionX(int wheel);
PXDECL float PXCALL pxWheelGetContactLonDirectionY(int wheel);
PXDECL float PXCALL pxWheelGetContactLonDirectionZ(int wheel);
PXDECL float PXCALL pxWheelGetContactLonImpulse(int wheel);
PXDECL int   PXCALL pxWheelGetContactMaterial(int wheel);
PXDECL float PXCALL pxWheelGetFrictionToSide(int wheel);
PXDECL float PXCALL pxWheelGetFrictionToFront(int wheel);

PXDECL void  PXCALL pxWheelSetMask(int wheel, int mask);
PXDECL void  PXCALL pxWheelSetMaskCombine(int wheel, int mask);
PXDECL void  PXCALL pxWheelClearMask(int wheel);
PXDECL void  PXCALL pxWheelDelete(int wheel);
PXDECL float PXCALL pxWheelSetEntity(int entity, int wheel, int step);


PXDECL int   PXCALL pxJointCreateSuspFront(int body0, int body1, float x, float y, float z);
PXDECL int   PXCALL pxJointCreateSuspBack(int body0, int body1, float x, float y, float z);
PXDECL void  PXCALL pxJointSuspSetSteerN(int joint, float x, float y, float z);
PXDECL void  PXCALL pxJointSuspSetTurnN(int joint, float x, float y, float z);
PXDECL void  PXCALL pxJointSuspSetLinLimit(int joint, float lim);
PXDECL void  PXCALL pxJointSuspSetLinParameter(int joint, float spring, float rest, float damp);
PXDECL void  PXCALL pxJointSuspSetAngLimit(int joint, float lim);
PXDECL void  PXCALL pxJointSuspSetAngParameter(int joint, float spring, float rest, float damp);
PXDECL void  PXCALL pxJointSuspSetAngle(int joint, float angle);
PXDECL void  PXCALL pxJointSuspSetSpeed(int joint, float speed);
PXDECL void  PXCALL pxJointSuspSetBrake(int joint, int mode);


PXDECL void  PXCALL pxCCDSkeletonEnable(int mode);
PXDECL void  PXCALL pxCCDSkeletonSetEpsilon(float eps);
PXDECL void  PXCALL pxBodySetCCDSkeleton(int body, float x, float y, float z);
PXDECL void  PXCALL pxBodySetCCDSkeletonThreshold(int body, float thres);
PXDECL void  PXCALL pxBodySetFlagCCDSkeletonDynamic(int body);
PXDECL int   PXCALL pxBodyGetCCDSkeleton(int body);
PXDECL void  PXCALL pxBodyDeleteCCDSkeleton(int ccd);


PXDECL int   PXCALL pxCreateRay();
PXDECL void  PXCALL pxRaySetDir(int ray, float nx, float ny, float nz);
PXDECL void  PXCALL pxRaySetPosition(int ray, float x, float y, float z);
PXDECL float PXCALL pxRayGetDistance(int ray, int mode);
PXDECL int   PXCALL pxRayGetBody(int ray, int mode);
PXDECL int   PXCALL pxRayGetMaterial(int ray, int mode);
PXDECL float PXCALL pxRayGetPickX(int ray, int mode);
PXDECL float PXCALL pxRayGetPickY(int ray, int mode);
PXDECL float PXCALL pxRayGetPickZ(int ray, int mode);
PXDECL float PXCALL pxRayGetPickNX(int ray, int mode);
PXDECL float PXCALL pxRayGetPickNY(int ray, int mode);
PXDECL float PXCALL pxRayGetPickNZ(int ray, int mode);


PXDECL int   PXCALL pxRegWriteDriverPath(char* str);
PXDECL int   PXCALL pxRegWriteString(int RootKey, char* Path, char* Name, char* Data);
PXDECL int   PXCALL pxRegWriteInt(int RootKey, char* Path, char* Name, int Data);
PXDECL int   PXCALL pxRegReadInt(int RootKey, char* Path, char* Name);
PXDECL char* PXCALL pxRegReadString(int RootKey, char* Path, char* Name);
PXDECL int   PXCALL pxRegDeleteValue(int RootKey, char* Path, char* Name);
PXDECL int   PXCALL pxRegDeleteKey(int RootKey, char* Path, char* Name);


PXDECL int   PXCALL pxGetContacts(int body);
PXDECL int   PXCALL pxContactGetBody(int body, int coll);
PXDECL float PXCALL pxContactGetPointX(int body, int coll);
PXDECL float PXCALL pxContactGetPointY(int body, int coll);
PXDECL float PXCALL pxContactGetPointZ(int body, int coll);
PXDECL float PXCALL pxContactGetPointNX(int body, int coll);
PXDECL float PXCALL pxContactGetPointNY(int body, int coll);
PXDECL float PXCALL pxContactGetPointNZ(int body, int coll);
PXDECL float PXCALL pxContactGetForceN(int body, int coll);
PXDECL float PXCALL pxContactGetForceNX(int body, int coll);
PXDECL float PXCALL pxContactGetForceNY(int body, int coll);
PXDECL float PXCALL pxContactGetForceNZ(int body, int coll);
PXDECL float PXCALL pxContactGetForceT(int body, int coll);
PXDECL float PXCALL pxContactGetForceTX(int body, int coll);
PXDECL float PXCALL pxContactGetForceTY(int body, int coll);
PXDECL float PXCALL pxContactGetForceTZ(int body, int coll);
PXDECL int   PXCALL pxContactEventsOnStartTouch(int body);
PXDECL int   PXCALL pxContactEventsOnEndTouch(int body);


PXDECL void  PXCALL pxMaskSet(int body, int mask);
PXDECL void  PXCALL pxMaskCombineSet(int body, int mask);
PXDECL void  PXCALL pxMaskClear(int body);
PXDECL void  PXCALL pxBodySetCollisionGroup(int body, int group);
PXDECL void  PXCALL pxBodySetCollisionGroupPair(int group1, int group2);
PXDECL void  PXCALL pxBodySetCollisionGroupFlag(int group1, int group2, int flag);
PXDECL void  PXCALL pxBodySetMagnetMask(int body, int mask);
PXDECL int   PXCALL pxBodyGetMagnetMask(int body);


PXDECL void  PXCALL pxBodySetFrozen(int body, int stat);
PXDECL void  PXCALL pxBodySetFrozenRotX(int body, int stat);
PXDECL void  PXCALL pxBodySetFrozenRotY(int body, int stat);
PXDECL void  PXCALL pxBodySetFrozenRotZ(int body, int stat);
PXDECL void  PXCALL pxBodySetFrozenRot(int body, int stat);
PXDECL void  PXCALL pxBodySetFrozenPosX(int body, int stat);
PXDECL void  PXCALL pxBodySetFrozenPosY(int body, int stat);
PXDECL void  PXCALL pxBodySetFrozenPosZ(int body, int stat);
PXDECL void  PXCALL pxBodySetFrozenPos(int body, int stat);
PXDECL void  PXCALL pxBodySetFlagGravity(int body, int stat);
PXDECL void  PXCALL pxBodySetFlagCollision(int body, int stat);
PXDECL void  PXCALL pxBodySetFlagResponse(int body, int stat);
PXDECL void  PXCALL pxBodySetFlagContacttable(int body, int stat);
PXDECL void  PXCALL pxBodySetFlagMagniteble(int body, int stat);
PXDECL void  PXCALL pxBodySetFlagTriggertable(int body, int stat);
PXDECL void  PXCALL pxBodySetFlagRayCast(int body, int stat);


PXDECL void  PXCALL pxDeleteBody(int num);
PXDECL void  PXCALL pxDeleteJoint(int joint);


PXDECL int   PXCALL pxJointCreateHinge(int body1, int body2, float x, float y, float z, float nx, float ny, float nz);
PXDECL int   PXCALL pxJointCreateSpherical(int body1, int body2, float x, float y, float z, float nx, float ny, float nz);
PXDECL int   PXCALL pxJointCreateDistance(int body1, int body2, float p1_x, float p1_y, float p1_z, float p2_x, float p2_y, float p2_z);
PXDECL int   PXCALL pxJointCreateFixed(int body1, int body2);
PXDECL int   PXCALL pxJointCreateCylindrical(int body1, int body2, float x, float y, float z, float nx, float ny, float nz, float min_limit, float max_limit);
PXDECL int   PXCALL pxJointCreatePrismatic(int body1, int body2, float x, float y, float z, float nx, float ny, float nz, float min_limit, float max_limit);
PXDECL int   PXCALL pxJointCreateOnLine(int body1, float x, float y, float z, float nx, float ny, float nz);
PXDECL int   PXCALL pxJointCreateInPlane(int body1, float x, float y, float z, float nx, float ny, float nz);
PXDECL int   PXCALL pxJointCreatePulley(int body1, int body2, float distance, float stiff, float k_ratio);

PXDECL int   PXCALL pxJointCreateD6Joint(int body1, int body2, float x, float y, float z, float nx, float ny, float nz);
PXDECL void  PXCALL pxD6JointSetPosMotion(int joint, int xMot, int yMot, int zMot);
PXDECL void  PXCALL pxD6JointSetAngleMotion(int joint, int twistMot, int swing1Mot, int swing2Mot);
PXDECL void  PXCALL pxD6JointSetLinearLimit(int joint, float lim);
PXDECL void  PXCALL pxD6JointSetSwingLimit(int joint, float swing1Lim, float swing2Lim);
PXDECL void  PXCALL pxD6JointSetTwistLimit(int joint, float lowLim, float heighLim);

PXDECL void  PXCALL pxJointHingeSetLimit(int joint, float min, float max);
PXDECL void  PXCALL pxJointHingeSetSpring(int joint, float spr, float targetVal);
PXDECL void  PXCALL pxJointSphericalSetLimitAngle(int joint, float angle, float hardn, float restit);
PXDECL void  PXCALL pxJointSphericalSetLimitTwist(int joint, float mintwist, float maxtwist, float spr, float damp, float targetVal);
PXDECL void  PXCALL pxJointSphericalSetLimitSpring(int joint, float spr, float damp, float targetVal);
PXDECL void  PXCALL pxJointDistanceSetPoint(int joint, float mindist, float maxdist);
PXDECL void  PXCALL pxJointDistanceSetSpring(int joint, float spr, float damp);
PXDECL void  PXCALL pxJointAddLimitPlane(int joint, float x, float y, float z, float nx, float ny, float nz);
PXDECL void  PXCALL pxJointPulleySetAnchor(int joint, float x1, float y1, float z1, float x2, float y2, float z2);
PXDECL void  PXCALL pxJointPulleySetLocalAttachBody(int joint, float x1, float y1, float z1, float x2, float y2, float z2);
PXDECL void  PXCALL pxJointHingeSetMotor(int joint, float force, float velTarget);
PXDECL void  PXCALL pxJointSetBreakable(int joint, float force, float torque);
PXDECL int   PXCALL pxJointIsBroken(int joint);
PXDECL void  PXCALL pxJointHingeSetCollision(int joint);
PXDECL void  PXCALL pxJointSphericalSetCollision(int joint);
PXDECL void  PXCALL pxJointDistanceSetCollision(int joint);
PXDECL void  PXCALL pxJointCylindricalSetCollision(int joint);


PXDECL void  PXCALL pxSetGravity(float gx, float gy, float gz);
PXDECL void  PXCALL pxBodySetMass(int num, float mass);
PXDECL void  PXCALL pxBodySetCMassLocalPosition(int num, float x, float y, float z);
PXDECL void  PXCALL pxBodySetCMassGlobalPosition(int num, float x, float y, float z);
PXDECL void  PXCALL pxBodySetMassSpaceInertiaTensor(int num, float x, float y, float z);
PXDECL float PXCALL pxBodyGetCMassGlobalPositionX(int body);
PXDECL float PXCALL pxBodyGetCMassGlobalPositionY(int body);
PXDECL float PXCALL pxBodyGetCMassGlobalPositionZ(int body);
PXDECL float PXCALL pxBodyGetCMassLocalPositionX(int body);
PXDECL float PXCALL pxBodyGetCMassLocalPositionY(int body);
PXDECL float PXCALL pxBodyGetCMassLocalPositionZ(int body);
PXDECL float PXCALL pxBodyGetMass(int body);


PXDECL void  PXCALL pxBodySetMyForce(int body, float lx, float ly, float lz);
PXDECL void  PXCALL pxBodyAddForce(int num, float vx, float vy, float vz, int mode);
PXDECL void  PXCALL pxBodyAddForceAtPos(int num, float vx, float vy, float vz, float px, float py, float pz, int mode);
PXDECL void  PXCALL pxBodyAddForceAtLocalPos(int body, float vx, float vy, float vz, float px, float py, float pz, int mode);
PXDECL void  PXCALL pxBodyAddLocalForce(int num, float vx, float vy, float vz, int mode);
PXDECL void  PXCALL pxBodyAddLocalForceAtPos(int num, float vx, float vy, float vz, float px, float py, float pz, int mode);
PXDECL void  PXCALL pxBodyAddLocalForceAtLocalPos(int body, float vx, float vy, float vz, float px, float py, float pz, int mode);

PXDECL void  PXCALL pxBodyAddTorque(int body, float vx, float vy, float vz, int mode);
PXDECL void  PXCALL pxBodyAddLocalTorque(int body, float vx, float vy, float vz, int mode);
PXDECL void  PXCALL pxBodySetAngularSpeed(int body, float ax, float ay, float az);
PXDECL void  PXCALL pxBodySetLinearSpeed(int body, float lx, float ly, float lz);
PXDECL void  PXCALL pxBodySetLocalLinearSpeed(int body, float lx, float ly, float lz);
PXDECL void  PXCALL pxBodySetLocalAngularSpeed(int body, float lx, float ly, float lz);
PXDECL void  PXCALL pxBodySetAngularDamping(int body, float angDamp);
PXDECL void  PXCALL pxBodySetLinearDamping(int body, float linDamp);
PXDECL void  PXCALL pxBodySetAngularMomentum(int body, float ax, float ay, float az);
PXDECL void  PXCALL pxBodySetLinearMomentum(int body, float lx, float ly, float lz);
PXDECL void  PXCALL pxBodySetMaxAngularSpeed(int body, float speed);
PXDECL void  PXCALL pxBodySetSleepEnergyThreshold(int body, float tres);
PXDECL void  PXCALL pxBodySetSleepAngularVelocity(int body, float tres);
PXDECL void  PXCALL pxBodySetSleepLinearVelocity(int body, float tres);
PXDECL void  PXCALL pxBodySetSleepWakeUp(int body, float wakeCounterValue);
PXDECL void  PXCALL pxBodySetSleepPut(int body);
PXDECL void  PXCALL pxBodySetSolverIterationCount(int body, int itercount);
PXDECL void  PXCALL pxBodySetBodyName(int body, char* name);
PXDECL void  PXCALL pxBodySetBodyEntity(int body, int entity);
PXDECL void  PXCALL pxBodySetBodyUserData(int body, int userdata);
PXDECL void  PXCALL pxMoveBodyToPoint(int body, float maxspeed, float x, float y, float z);
PXDECL void  PXCALL pxAddBodytoBody(int body1, int body2);
PXDECL int   PXCALL pxCopyBody(int body);


PXDECL int   PXCALL pxCreateMaterial();
PXDECL void  PXCALL pxMaterialSetToBody(int body, int mat);
PXDECL void  PXCALL pxMaterialSetRestitution(int mat, float rest);
PXDECL void  PXCALL pxMaterialSetRestitutionCombineMode(int mat, int mode);
PXDECL void  PXCALL pxMaterialSetStFriction(int mat, float fric);
PXDECL void  PXCALL pxMaterialSetDyFriction(int mat, float fric);
PXDECL void  PXCALL pxMaterialSetFrictionV(int mat, float sfric, float dfric);
PXDECL void  PXCALL pxMaterialSetFrictionCombineMode(int mat, int mode);
PXDECL int   PXCALL pxCreateAnisotripicMaterial(float nx, float ny, float nz);
PXDECL void  PXCALL pxMaterialSetFlagStrongFriction(int mat);
PXDECL int   PXCALL pxGetMaterial(int body);


PXDECL void  PXCALL pxBodySetPosition(int num, float pos_x, float pos_y, float pos_z);
PXDECL void  PXCALL pxBodySetRotation(int num, float pitch, float yaw, float roll);

PXDECL float PXCALL pxBodyGetPositionX(int num);
PXDECL float PXCALL pxBodyGetPositionY(int num);
PXDECL float PXCALL pxBodyGetPositionZ(int num);
PXDECL float PXCALL pxBodyGetRotationPitch(int num);
PXDECL float PXCALL pxBodyGetRotationYaw(int num);
PXDECL float PXCALL pxBodyGetRotationRoll(int num);
PXDECL float PXCALL pxBodyGetAngularSpeed(int num);
PXDECL float PXCALL pxBodyGetAngularSpeedX(int num);
PXDECL float PXCALL pxBodyGetAngularSpeedY(int num);
PXDECL float PXCALL pxBodyGetAngularSpeedZ(int num);
PXDECL float PXCALL pxBodyGetLocalAngularSpeedX(int body);
PXDECL float PXCALL pxBodyGetLocalAngularSpeedY(int body);
PXDECL float PXCALL pxBodyGetLocalAngularSpeedZ(int body);
PXDECL float PXCALL pxBodyGetLinearSpeed(int num);
PXDECL float PXCALL pxBodyGetLinearSpeedX(int num);
PXDECL float PXCALL pxBodyGetLinearSpeedY(int num);
PXDECL float PXCALL pxBodyGetLinearSpeedZ(int num);
PXDECL float PXCALL pxBodyGetLocalLinearSpeedX(int body);
PXDECL float PXCALL pxBodyGetLocalLinearSpeedY(int body);
PXDECL float PXCALL pxBodyGetLocalLinearSpeedZ(int body);
PXDECL float PXCALL pxBodyGetLinearVecSpeedX(int num);
PXDECL float PXCALL pxBodyGetLinearVecSpeedY(int num);
PXDECL float PXCALL pxBodyGetLinearVecSpeedZ(int num);
PXDECL float  PXCALL pxBodyGetLocalPointSpeed(int body, float x, float y, float z);
PXDECL float  PXCALL pxBodyGetLocalPointSpeedX(int body, float x, float y, float z);
PXDECL float  PXCALL pxBodyGetLocalPointSpeedY(int body, float x, float y, float z);
PXDECL float  PXCALL pxBodyGetLocalPointSpeedZ(int body, float x, float y, float z);


PXDECL float PXCALL pxBodyGetAngularDamping(int body);
PXDECL float PXCALL pxBodyGetLinearDamping(int body);
PXDECL float PXCALL pxBodyGetAngularMomentum(int body);
PXDECL float PXCALL pxBodyGetLinearMomentum(int body);
PXDECL float PXCALL pxBodyGetMaxAngularVelocity(int body);
PXDECL char* PXCALL pxGetBodyName(int body);
PXDECL int   PXCALL pxGetBodyEntity(int body);
PXDECL int   PXCALL pxGetBodyUserData(int body);
PXDECL float PXCALL pxBodyGetSleepAngularVelocity(int body);
PXDECL float PXCALL pxBodyGetSleepLinearVelocity(int body);
PXDECL int   PXCALL pxBodyIsDynamic(int body);
PXDECL int   PXCALL pxBodyIsSleeping(int body);


PXDECL int   PXCALL pxGetNumberAllBody();
PXDECL int   PXCALL pxCreateWorld(int plane, char* password);
PXDECL void  PXCALL pxDestroyWorld();
PXDECL void  PXCALL pxRenderPhysic(float time, int sinc);
PXDECL void  PXCALL pxSetTiming(float maxTimeStep, int maxIter, int StepMethod);
PXDECL void  PXCALL pxSDKSetParameter(float param);
PXDECL void  PXCALL pxSetPause(int pause);
PXDECL int   PXCALL pxChekPPU();
PXDECL int   PXCALL pxChekPPUMode();
PXDECL void  PXCALL pxSetHardwareSimulation(int mode);

PXDECL int   PXCALL pxCreateScene();
PXDECL void  PXCALL pxSceneChange(int scene);


PXDECL int   PXCALL pxBodySetEntity(int entity, int body);
PXDECL void  PXCALL pxBodyAddEntity(int entity, int body);
PXDECL int   PXCALL pxDX9BodySetEntity(int entity, int body);

PXDECL int   PXCALL pxBufferCreate(int size);
PXDECL void  PXCALL pxBufferSetElement(int buff, int nelem, float elem);
PXDECL float PXCALL pxBufferGetElement(int buff, int elem);
PXDECL void  PXCALL pxBufferDelete(int buff);

PXDECL int   PXCALL peeksint(int addr);

PXDECL float PXCALL pxGetAngleBetweenVec(float v1x, float v1y, float v1z, float v2x, float v2y, float v2z);


PXDECL float PXCALL pxBodyGetRotationQuatX(int body);
PXDECL float PXCALL pxBodyGetRotationQuatY(int body);
PXDECL float PXCALL pxBodyGetRotationQuatZ(int body);
PXDECL float PXCALL pxBodyGetRotationQuatW(int body);
