#ifndef _PX_PARSER_H_
#define _PX_PARSER_H_

std::vector<pxBody*>	gDynBodies;
std::vector<int>		gDynMeshes;

char* pxGetBodyFromMesh(int mesh)
{

	int num_child = xCountChildren(mesh);
	for (int i = 0; i<num_child; i++)
	{
		int child = xGetChild (mesh, i);
		if (child)
		{
			std::string child_name = xEntityName (child);

			float child_x = xEntityX(child,1);
			float child_y = xEntityY(child,1);
			float child_z = xEntityZ(child,1);

			float child_dimens_x = xMeshWidth(child)*0.5*xEntityScaleX(child);
			float child_dimens_y = xMeshHeight (child)*0.5*xEntityScaleY(child);
			float child_dimens_z = xMeshDepth(child)*0.5*xEntityScaleZ(child);

			float child_angle_pitch = xEntityPitch(child);
			float child_angle_yaw = xEntityYaw(child);
			float child_angle_roll = xEntityRoll(child);


			pxBody* physMesh_body = new pxBody;
			if((int)child_name.find("\\cu")>1)
			{
				int FirstNumber_massName = child_name.find("\\m");
				int LastNumber_massName = child_name.find("\\", FirstNumber_massName + 1);
				int Lenght_massName = LastNumber_massName - FirstNumber_massName - 2;
				std::string Last_massName = child_name.substr(FirstNumber_massName+2,Lenght_massName);
				float mass;
				sscanf(Last_massName.c_str(),"%f", &mass);
				if (mass<0.1) mass = 0;

				xMoveEntity (child,0,child_dimens_y,0);

				physMesh_body->CreateCube(child_dimens_x, child_dimens_y, child_dimens_z, mass);
				physMesh_body->SetPosition( xEntityX(child,1), xEntityY(child,1), xEntityZ(child,1));
				physMesh_body->SetRotation(xEntityPitch (child), xEntityYaw (child), xEntityRoll (child));
				int physMesh_mesh = child;

				if (mass>0.1)
				{
					gDynBodies.push_back(physMesh_body);
					gDynMeshes.push_back(child);
				}

				xMoveEntity (child,0,-child_dimens_y,0);
				xRotateEntity (child,0,0,0);
				xPositionMesh (child,0,-xMeshHeight(child)*0.5,0);
				xRotateEntity (child, child_angle_pitch, child_angle_yaw, child_angle_roll);
			

			} else
			if((int)child_name.find("\\sp")>1)
			{
				int FirstNumber_massName = child_name.find("\\m");
				int LastNumber_massName = child_name.find("\\", FirstNumber_massName + 1);
				int Lenght_massName = LastNumber_massName - FirstNumber_massName - 2;
				std::string Last_massName = child_name.substr(FirstNumber_massName+2,Lenght_massName);
				float mass;
				sscanf(Last_massName.c_str(),"%f", &mass);
				if (mass<0.1) mass = 0;

			//	pxBody* physMesh_body = new pxBody;
				physMesh_body->CreateSphere(child_dimens_x, mass);
				physMesh_body->SetPosition(xEntityX(child,1), xEntityY(child,1), xEntityZ(child,1));
				physMesh_body->SetRotation(xEntityPitch (child), xEntityYaw (child), xEntityRoll (child));
				int physMesh_mesh = child;

				if (mass>0.1)
				{
					gDynBodies.push_back(physMesh_body);
					gDynMeshes.push_back(child);
				}

			} else
			if((int)child_name.find("\\hul")>1)
			{
				int FirstNumber_massName = child_name.find("\\m");
				int LastNumber_massName = child_name.find("\\", FirstNumber_massName + 1);
				int Lenght_massName = LastNumber_massName - FirstNumber_massName - 2;
				std::string Last_massName = child_name.substr(FirstNumber_massName+2,Lenght_massName);
				float mass;
				sscanf(Last_massName.c_str(),"%f", &mass);
				if (mass<0.1) mass = 0;

			//	pxBody* physMesh_body = new pxBody;
				float* VB = xGetMeshVB(child);
				int VB_size = xGetMeshVBSize(child);
				physMesh_body->CreateHull(VB, VB_size, mass);
				physMesh_body->SetPosition(xEntityX(child,1), xEntityY(child,1), xEntityZ(child,1));
				physMesh_body->SetRotation(xEntityPitch (child), xEntityYaw (child), xEntityRoll (child));
				int physMesh_mesh = child;

				if (mass>0.1)
				{
					gDynBodies.push_back(physMesh_body);
					gDynMeshes.push_back(child);
				}

			} else
			if((int)child_name.find("\\trm")>1)
			{
			/*	int FirstNumber_massName = child_name.find("\\m");
				int LastNumber_massName = child_name.find("\\", FirstNumber_massName + 1);
				int Lenght_massName = LastNumber_massName - FirstNumber_massName - 2;
				std::string Last_massName = child_name.substr(FirstNumber_massName+2,Lenght_massName);
				float mass;
				sscanf(Last_massName.c_str(),"%f", &mass);*/

			//	pxBody* physMesh_body = new pxBody;
				float* VB = xGetMeshVB(child);
				int VB_size = xGetMeshVBSize(child);
				int* IB = xGetMeshIB(child);
				int IB_size = xGetMeshIBSize(child);
				physMesh_body->CreateTriMesh(VB, IB, VB_size, IB_size, 0);
				physMesh_body->SetPosition(xEntityX(child,1), xEntityY(child,1), xEntityZ(child,1));
				physMesh_body->SetRotation(xEntityPitch (child), xEntityYaw (child), xEntityRoll (child));
				int physMesh_mesh = child;

			}
			else delete [] physMesh_body;
			// materials
			if((int)child_name.find("\\fr")>1)
			{
				int FirstNumber_massName = child_name.find("\\fr");
				int LastNumber_massName = child_name.find("\\", FirstNumber_massName + 1);
				int Lenght_massName = LastNumber_massName - FirstNumber_massName - 3;
				std::string Last_massName = child_name.substr(FirstNumber_massName+3,Lenght_massName);
				float fric;
				sscanf(Last_massName.c_str(),"%f", &fric);

				pxMaterial* m_material = new pxMaterial;
				m_material->Create();
				m_material->SetStFriction(fric);
				m_material->SetDyFriction(0.5*fric);
				m_material->SetToBody(physMesh_body->_body);
			}

		}
	}

	return 0;
}

void pxUpdateBodyFromMesh()
{
	std::vector<pxBody*>::iterator dBodies = gDynBodies.begin();
	std::vector<int>::iterator dMeshes = gDynMeshes.begin();
	while(dBodies != gDynBodies.end())
	{
		xPositionEntity(*dMeshes, (Vector3)(*dBodies)->GetPosition());
		xRotateEntity(*dMeshes, (*dBodies)->GetRotation().x, (*dBodies)->GetRotation().y, (*dBodies)->GetRotation().z);
		dBodies++;
		dMeshes++;
	}
}

#endif