#ifndef _PX_CLOTH_H_
#define _PX_CLOTH_H_

class pxCloth
{
public:
	int _cloth;
public:
	pxCloth();
	void	Update();
	void	Delete();
	void	Create(int entity, int surf);
	void	CreateTearable(int entity, int surf);
	void	CreateMetal(int entity, int surf, int coreActor, float impThr, float depth);
	void	CreateSpec(int vbank, int fbank, int MESH_NBVERTICES, int MESH_NBFACES);
	void	CreateMetalSpec(int vbank, int fbank, int MESH_NBVERTICES, int MESH_NBFACES, int coreActor, float impThr, float depth);

	float	GetAttachmentResponseCoefficient();
	float	GetAttachmentTearFactor();
	float	GetBendingStiffness();
	float	GetCollisionResponseCoefficient();
	float	GetDampingCoefficient();
	float	GetDensity();
	float	GetFriction();
	float	GetPressure();
	float	GetSleepLinearVelocity();
	float	GetStretchingStiffness();
	float	GetTearFactor();
	float	GetThickness();
	int		GetNumVertices();
	int		IsSleeping();
	int		GetEntity();
	int		GetUserData();
	void	PutToSleep();
	void	WakeUp();
	void	SetGravity(int stat);

	void	SetAttachmentResponseCoefficient(float coef);
	void	SetAttachmentTearFactor(float coef);
	void	SetBending();
	void	SetBendingStiffness(float coef);
	void	SetCollisionResponseCoefficient(float coef);
	void	SetDampingCoefficient(float coef);
	void	SetComDampingCoefficient(float coef);
	void	SetFriction(float coef);
	void	SetPressure(float coef);
	void	SetSleepLinearVelocity(float coef);
	void	SetStretchingStiffness(float coef);
	void	SetThickness(float coef);
	void	SetUserData(int userdata);
	void	SetMask(int mask);
	void	SetMaskCombine(int mask);

	void	SetVertexPos(int vbank, int numVert);
	void	GetVertexPos(int vbank, int numVert);
	void	GetNormals(int nbank);
	void	AttachVertexToPos(int vID, float pos_x, float pos_y, float pos_z);
	void	AttachToCollidingShapes(int flag);
	void	AttachToCore(int body, float Threshold, float Depth);
	void	AttachToShape(int body, int flag);
	void	DetachFromShape(int body);
	void	FreeVertex(int vID);
	void	AddForceAtPos(float pos_x, float pos_y, float pos_z, float magnitude, float radius);
	void	AddForceAtVertex(float nx, float ny, float nz, int vID);

	void	SetTeareble();
	void	SetTearFactor(float coef);
};

pxCloth::pxCloth()
{
	_cloth = 0;
}

void pxCloth::Create(int entity, int surf)
{
	_cloth = pxCreateCloth(entity, surf);
}
void pxCloth::CreateTearable(int entity, int surf)
{
	_cloth = pxCreateTearableCloth(entity, surf);
}
void pxCloth::CreateMetal(int entity, int surf, int coreActor, float impThr, float depth)
{
	_cloth = pxCreateMetalCloth(entity, surf, coreActor, impThr, depth);
}
void pxCloth::CreateSpec(int vbank, int fbank, int MESH_NBVERTICES, int MESH_NBFACES)
{
	_cloth = pxCreateClothSpec(vbank, fbank, MESH_NBVERTICES, MESH_NBFACES);
}
void pxCloth::CreateMetalSpec(int vbank, int fbank, int MESH_NBVERTICES, int MESH_NBFACES, int coreActor, float impThr, float depth)
{
	_cloth = pxCreateMetalClothSpec(vbank, fbank, MESH_NBVERTICES, MESH_NBFACES, coreActor, impThr, depth);
}




float pxCloth::GetAttachmentResponseCoefficient()
{
	return pxClothGetAttachmentResponseCoefficient(_cloth);
}
float pxCloth::GetAttachmentTearFactor()
{
	return pxClothGetAttachmentTearFactor(_cloth);
}
float pxCloth::GetBendingStiffness()
{
	return pxClothGetBendingStiffness(_cloth);
}
float pxCloth::GetCollisionResponseCoefficient()
{
	return pxClothGetCollisionResponseCoefficient(_cloth);
}
float pxCloth::GetDampingCoefficient()
{
	return pxClothGetDampingCoefficient(_cloth);
}
float pxCloth::GetDensity()
{
	return pxClothGetDensity(_cloth);
}
float pxCloth::GetFriction()
{
	return pxClothGetFriction(_cloth);
}
float pxCloth::GetPressure()
{
	return pxClothGetPressure(_cloth);
}
float pxCloth::GetSleepLinearVelocity()
{
	return pxClothGetSleepLinearVelocity(_cloth);
}
float pxCloth::GetStretchingStiffness()
{
	return pxClothGetStretchingStiffness(_cloth);
}
float pxCloth::GetTearFactor()
{
	return pxClothGetTearFactor(_cloth);
}
float pxCloth::GetThickness()
{
	return pxClothGetThickness(_cloth);
}
int pxCloth::GetNumVertices()
{
	return pxClothGetNumVertices(_cloth);
}
int pxCloth::IsSleeping()
{
	return pxClothIsSleeping(_cloth);
}
int pxCloth::GetEntity()
{
	return pxClothGetEntity(_cloth);
}
int pxCloth::GetUserData()
{
	return pxClothGetUserData(_cloth);
}
void pxCloth::PutToSleep()
{
	pxClothPutToSleep(_cloth);
}
void pxCloth::WakeUp()
{
	pxClothWakeUp(_cloth);
}
void pxCloth::SetGravity(int stat)
{
	pxClothSetGravity(_cloth, stat);
}




void pxCloth::SetAttachmentResponseCoefficient(float coef)
{
	pxClothSetAttachmentResponseCoefficient(_cloth, coef);
}
void pxCloth::SetAttachmentTearFactor(float coef)
{
	pxClothSetAttachmentTearFactor(_cloth, coef);
}
void pxCloth::SetBending()
{
	pxClothSetBending(_cloth);
}
void pxCloth::SetBendingStiffness(float coef)
{
	pxClothSetBendingStiffness(_cloth, coef);
}
void pxCloth::SetCollisionResponseCoefficient(float coef)
{
	pxClothSetCollisionResponseCoefficient(_cloth, coef);
}
void pxCloth::SetDampingCoefficient(float coef)
{
	pxClothSetDampingCoefficient(_cloth, coef);
}
void pxCloth::SetComDampingCoefficient(float coef)
{
	pxClothSetComDampingCoefficient(_cloth, coef);
}
void pxCloth::SetFriction(float coef)
{
	pxClothSetFriction(_cloth,  coef);
}
void pxCloth::SetPressure(float coef)
{
	pxClothSetPressure(_cloth, coef);
}
void pxCloth::SetSleepLinearVelocity(float coef)
{
	pxClothSetSleepLinearVelocity(_cloth, coef);
}
void pxCloth::SetStretchingStiffness(float coef)
{
	pxClothSetStretchingStiffness(_cloth, coef);
}
void pxCloth::SetThickness(float coef)
{
	pxClothSetThickness(_cloth, coef);
}
void pxCloth::SetUserData(int userdata)
{
	pxClothSetUserData(_cloth,  userdata);
}
void pxCloth::SetMask(int mask)
{
	pxClothMaskSet(_cloth, mask);
}
void pxCloth::SetMaskCombine(int mask)
{
	pxClothMaskCombineSet(_cloth, mask);
}




void pxCloth::SetVertexPos(int vbank, int numVert)
{
	pxClothSetVertexPos(_cloth, vbank, numVert);
}
void pxCloth::GetVertexPos(int vbank, int numVert)
{
	pxClothGetVertexPos(_cloth, vbank, numVert);
}
void pxCloth::GetNormals(int nbank)
{
	pxClothGetNormals(_cloth, nbank);
}

void pxCloth::AttachVertexToPos(int vID, float pos_x, float pos_y, float pos_z)
{
	pxClothAttachVertexToPos(_cloth, vID, pos_x, pos_y, pos_z);
}
void pxCloth::AttachToCollidingShapes(int flag)
{
	pxClothAttachToCollidingShapes(_cloth, flag);
}
void pxCloth::AttachToCore(int body, float Threshold, float Depth)
{
	pxClothAttachToCore(_cloth, body, Threshold, Depth);
}
void pxCloth::AttachToShape(int body, int flag)
{
	pxClothAttachToShape(_cloth, body, flag);
}
void pxCloth::DetachFromShape(int body)
{
	pxClothDetachFromShape(_cloth, body);
}
void pxCloth::FreeVertex(int vID)
{
	pxClothFreeVertex(_cloth, vID);
}
void pxCloth::AddForceAtPos(float pos_x, float pos_y, float pos_z, float magnitude, float radius)
{
	pxClothAddForceAtPos(_cloth, pos_x, pos_y, pos_z, magnitude, radius);
}
void pxCloth::AddForceAtVertex(float nx, float ny, float nz, int vID)
{
	pxClothAddForceAtVertex(_cloth, nx, ny, nz, vID);
}
void pxCloth::Update()
{
	pxUpdateCloth();
}
void pxCloth::Delete()
{
	pxClothDelete(_cloth);
}



void pxCloth::SetTeareble()
{
	pxClothSetTeareble(_cloth);
}
void pxCloth::SetTearFactor(float coef)
{
	pxClothSetTearFactor(_cloth, coef);
}

#endif