#ifndef _PX_MATERIAL_H_
#define _PX_MATERIAL_H_

class pxMaterial
{
public:
	int _material;
public:
	pxMaterial();
	void Create();
	void SetToBody(int body);
	void SetRestitution(float rest);
	void SetRestitutionCombineMode(int mode);
	void SetStFriction(float fric);
	void SetDyFriction(float fric);
	void SetFrictionV(float sfric, float dfric);
	void SetFrictionCombineMode(int mode);
	void CreateAnisotripic(float nx, float ny, float nz);
	void SetFlagStrongFriction();
	int GetMaterial(int body);

};

pxMaterial::pxMaterial()
{
	_material = 0;
}

void pxMaterial::Create()
{
	_material = pxCreateMaterial();
}
void pxMaterial::SetToBody(int body)
{
	pxMaterialSetToBody(body, _material);
}
void pxMaterial::SetRestitution(float rest)
{
	pxMaterialSetRestitution(_material, rest);
}
void pxMaterial::SetRestitutionCombineMode(int mode)
{
	pxMaterialSetRestitutionCombineMode(_material, mode);
}
void pxMaterial::SetStFriction(float fric)
{
	pxMaterialSetStFriction(_material, fric);
}
void pxMaterial::SetDyFriction(float fric)
{
	pxMaterialSetDyFriction(_material, fric);
}
void pxMaterial::SetFrictionV(float sfric, float dfric)
{
	pxMaterialSetFrictionV(_material, sfric, dfric);
}
void pxMaterial::SetFrictionCombineMode(int mode)
{
	pxMaterialSetFrictionCombineMode(_material, mode);
}
void pxMaterial::CreateAnisotripic(float nx, float ny, float nz)
{
	_material = pxCreateAnisotripicMaterial(nx, ny, nz);
}
void pxMaterial::SetFlagStrongFriction()
{
	pxMaterialSetFlagStrongFriction(_material);
}
int pxMaterial::GetMaterial(int body)
{
	return pxGetMaterial(body);
}

#endif