#ifndef _PX_RAY_H_
#define _PX_RAY_H_

class pxRay
{
public:
	int _ray;
public:
	pxRay();

	void	Create();
	void	SetDir(Vector3 norm);
	void	SetPosition(Vector3 pos);
	float	GetDistance(int mode);
	int		GetBody(int mode);
	int		GetMaterial(int mode);
	Vector3 GetPickPoint(int mode);
	Vector3 GetPickPointN(int mode);
};

pxRay::pxRay()
{
	_ray = 0;
}

void pxRay::Create()
{
	 _ray = pxCreateRay();
}
void pxRay::SetDir(Vector3 norm)
{
	 pxRaySetDir(_ray, norm.x, norm.y, norm.z);
}
void pxRay::SetPosition(Vector3 pos)
{
	 pxRaySetPosition(_ray, pos.x, pos.y, pos.z);
}
float pxRay::GetDistance(int mode = 0)
{
	 return pxRayGetDistance(_ray, mode);
}
int pxRay::GetBody(int mode = 0)
{
	 return pxRayGetBody(_ray, mode);
}
int pxRay::GetMaterial(int mode = 0)
{
	 return pxRayGetMaterial(_ray, mode);
}
Vector3 pxRay::GetPickPoint(int mode = 0)
{
	 return Vector3(pxRayGetPickX(_ray, mode), pxRayGetPickY(_ray, mode), pxRayGetPickZ(_ray, mode));
}
Vector3 pxRay::GetPickPointN(int mode = 0)
{
	 return Vector3(pxRayGetPickNX(_ray, mode), pxRayGetPickNY(_ray, mode), pxRayGetPickNZ(_ray, mode));
}

#endif