#ifndef _PX_TRIGGER_H_
#define _PX_TRIGGER_H_

class pxTrigger
{
public:
	int _trigger;
public:
	pxTrigger();
	void	CreateCube(float dx, float dy, float dz);
	void	CreateSphere(float radius);
	void	CreateCapsule(float height, float radius);
	void	CreateCylinder(float radius, float height, int nbEdge);
	void	CreateHull(int vbank, int nvert);
	void	SetPosition(Vector3 pos);
	void	SetRotation(Vector3 rot);
	int		GetNumBody();
	int		GetBody(int num);
	int		GetBodyTrigger(int body);
	void	Update();

};

pxTrigger::pxTrigger()
{
	_trigger = 0;
}

void pxTrigger::CreateCube(float dx, float dy, float dz)
{
	_trigger = pxTriggerCreateCube(dx, dy, dz);
}
void pxTrigger::CreateSphere(float radius)
{
	_trigger = pxTriggerCreateSphere(radius);
}
void pxTrigger::CreateCapsule(float height, float radius)
{
	_trigger = pxTriggerCreateCapsule(height, radius);
}
void pxTrigger::CreateCylinder(float radius, float height, int nbEdge)
{
	_trigger = pxTriggerCreateCylinder(radius, height, nbEdge);
}
void pxTrigger::CreateHull(int vbank, int nvert)
{
	_trigger = pxTriggerCreateHull(vbank, nvert);
}
void pxTrigger::SetPosition(Vector3 pos)
{
	pxTriggerSetPosition(_trigger, pos.x, pos.y, pos.z);
}
void pxTrigger::SetRotation(Vector3 rot)
{
	pxTriggerSetRotation(_trigger, rot.x, rot.y, rot.z);
}
int pxTrigger::GetNumBody()
{
	return pxTriggerGetNumBody(_trigger);
}
int pxTrigger::GetBody(int num)
{
	return pxTriggerGetBody(_trigger, num);
}
int pxTrigger::GetBodyTrigger(int body)
{
	return pxTriggerGetBodyTrigger(body);
}
void pxTrigger::Update()
{
	pxUpdateTriggers();
}

#endif